/* SystemInterface.c generated by valac 0.56.18, the Vala compiler
 * generated from SystemInterface.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2024 elementary, Inc. (https://elementary.io)
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include "quick-settings.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define TYPE_USER_INFO (user_info_get_type ())
typedef struct _UserInfo UserInfo;
#define _g_free0(var) (var = (g_free (var), NULL))

#define QUICK_SETTINGS_TYPE_SYSTEM_INTERFACE (quick_settings_system_interface_get_type ())
#define QUICK_SETTINGS_SYSTEM_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), QUICK_SETTINGS_TYPE_SYSTEM_INTERFACE, QuickSettingsSystemInterface))
#define QUICK_SETTINGS_IS_SYSTEM_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), QUICK_SETTINGS_TYPE_SYSTEM_INTERFACE))
#define QUICK_SETTINGS_SYSTEM_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), QUICK_SETTINGS_TYPE_SYSTEM_INTERFACE, QuickSettingsSystemInterfaceIface))

typedef struct _QuickSettingsSystemInterface QuickSettingsSystemInterface;
typedef struct _QuickSettingsSystemInterfaceIface QuickSettingsSystemInterfaceIface;

#define QUICK_SETTINGS_TYPE_SYSTEM_INTERFACE_PROXY (quick_settings_system_interface_proxy_get_type ())
typedef GDBusProxy QuickSettingsSystemInterfaceProxy;
typedef GDBusProxyClass QuickSettingsSystemInterfaceProxyClass;

struct _UserInfo {
	guint32 uid;
	gchar* user_name;
	char* user_object;
};

struct _QuickSettingsSystemInterfaceIface {
	GTypeInterface parent_iface;
	void (*suspend) (QuickSettingsSystemInterface* self, gboolean interactive, GError** error);
	void (*reboot) (QuickSettingsSystemInterface* self, gboolean interactive, GError** error);
	void (*power_off) (QuickSettingsSystemInterface* self, gboolean interactive, GError** error);
	void (*reboot_with_flags) (QuickSettingsSystemInterface* self, guint64 flags, GError** error);
	void (*power_off_with_flags) (QuickSettingsSystemInterface* self, guint64 flags, GError** error);
	UserInfo* (*list_users) (QuickSettingsSystemInterface* self, gint* result_length1, GError** error);
	gchar* (*can_suspend) (QuickSettingsSystemInterface* self, GError** error);
};

VALA_EXTERN GType user_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN UserInfo* user_info_dup (const UserInfo* self);
VALA_EXTERN void user_info_free (UserInfo* self);
VALA_EXTERN void user_info_copy (const UserInfo* self,
                     UserInfo* dest);
VALA_EXTERN void user_info_destroy (UserInfo* self);
VALA_EXTERN GType quick_settings_system_interface_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint quick_settings_system_interface_register_object (void* object,
                                                       GDBusConnection* connection,
                                                       const gchar* path,
                                                       GError** error);
VALA_EXTERN GType quick_settings_system_interface_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void quick_settings_system_interface_suspend (QuickSettingsSystemInterface* self,
                                              gboolean interactive,
                                              GError** error);
VALA_EXTERN void quick_settings_system_interface_reboot (QuickSettingsSystemInterface* self,
                                             gboolean interactive,
                                             GError** error);
VALA_EXTERN void quick_settings_system_interface_power_off (QuickSettingsSystemInterface* self,
                                                gboolean interactive,
                                                GError** error);
VALA_EXTERN void quick_settings_system_interface_reboot_with_flags (QuickSettingsSystemInterface* self,
                                                        guint64 flags,
                                                        GError** error);
VALA_EXTERN void quick_settings_system_interface_power_off_with_flags (QuickSettingsSystemInterface* self,
                                                           guint64 flags,
                                                           GError** error);
VALA_EXTERN UserInfo* quick_settings_system_interface_list_users (QuickSettingsSystemInterface* self,
                                                      gint* result_length1,
                                                      GError** error);
VALA_EXTERN gchar* quick_settings_system_interface_can_suspend (QuickSettingsSystemInterface* self,
                                                    GError** error);
static GType quick_settings_system_interface_get_type_once (void);
static void quick_settings_system_interface_proxy_g_signal (GDBusProxy* proxy,
                                                     const gchar* sender_name,
                                                     const gchar* signal_name,
                                                     GVariant* parameters);
static void quick_settings_system_interface_proxy_suspend (QuickSettingsSystemInterface* self,
                                                    gboolean interactive,
                                                    GError** error);
static void quick_settings_system_interface_proxy_reboot (QuickSettingsSystemInterface* self,
                                                   gboolean interactive,
                                                   GError** error);
static void quick_settings_system_interface_proxy_power_off (QuickSettingsSystemInterface* self,
                                                      gboolean interactive,
                                                      GError** error);
static void quick_settings_system_interface_proxy_reboot_with_flags (QuickSettingsSystemInterface* self,
                                                              guint64 flags,
                                                              GError** error);
static void quick_settings_system_interface_proxy_power_off_with_flags (QuickSettingsSystemInterface* self,
                                                                 guint64 flags,
                                                                 GError** error);
static UserInfo* quick_settings_system_interface_proxy_list_users (QuickSettingsSystemInterface* self,
                                                            gint* result_length1,
                                                            GError** error);
static gchar* quick_settings_system_interface_proxy_can_suspend (QuickSettingsSystemInterface* self,
                                                          GError** error);
static void quick_settings_system_interface_proxy_quick_settings_system_interface_interface_init (QuickSettingsSystemInterfaceIface* iface);
static void _dbus_quick_settings_system_interface_suspend (QuickSettingsSystemInterface* self,
                                                    GVariant* _parameters_,
                                                    GDBusMethodInvocation* invocation);
static void _dbus_quick_settings_system_interface_reboot (QuickSettingsSystemInterface* self,
                                                   GVariant* _parameters_,
                                                   GDBusMethodInvocation* invocation);
static void _dbus_quick_settings_system_interface_power_off (QuickSettingsSystemInterface* self,
                                                      GVariant* _parameters_,
                                                      GDBusMethodInvocation* invocation);
static void _dbus_quick_settings_system_interface_reboot_with_flags (QuickSettingsSystemInterface* self,
                                                              GVariant* _parameters_,
                                                              GDBusMethodInvocation* invocation);
static void _dbus_quick_settings_system_interface_power_off_with_flags (QuickSettingsSystemInterface* self,
                                                                 GVariant* _parameters_,
                                                                 GDBusMethodInvocation* invocation);
static void _vala_UserInfo_array_free (UserInfo * array,
                                gssize array_length);
static void _dbus_quick_settings_system_interface_list_users (QuickSettingsSystemInterface* self,
                                                       GVariant* _parameters_,
                                                       GDBusMethodInvocation* invocation);
static void _dbus_quick_settings_system_interface_can_suspend (QuickSettingsSystemInterface* self,
                                                        GVariant* _parameters_,
                                                        GDBusMethodInvocation* invocation);
static void quick_settings_system_interface_dbus_interface_method_call (GDBusConnection* connection,
                                                                 const gchar* sender,
                                                                 const gchar* object_path,
                                                                 const gchar* interface_name,
                                                                 const gchar* method_name,
                                                                 GVariant* parameters,
                                                                 GDBusMethodInvocation* invocation,
                                                                 gpointer user_data);
static GVariant* quick_settings_system_interface_dbus_interface_get_property (GDBusConnection* connection,
                                                                       const gchar* sender,
                                                                       const gchar* object_path,
                                                                       const gchar* interface_name,
                                                                       const gchar* property_name,
                                                                       GError** error,
                                                                       gpointer user_data);
static gboolean quick_settings_system_interface_dbus_interface_set_property (GDBusConnection* connection,
                                                                      const gchar* sender,
                                                                      const gchar* object_path,
                                                                      const gchar* interface_name,
                                                                      const gchar* property_name,
                                                                      GVariant* value,
                                                                      GError** error,
                                                                      gpointer user_data);
static void _quick_settings_system_interface_unregister_object (gpointer user_data);

static const GDBusArgInfo _quick_settings_system_interface_dbus_arg_info_suspend_interactive = {-1, "interactive", "b", NULL};
static const GDBusArgInfo * const _quick_settings_system_interface_dbus_arg_info_suspend_in[] = {&_quick_settings_system_interface_dbus_arg_info_suspend_interactive, NULL};
static const GDBusArgInfo * const _quick_settings_system_interface_dbus_arg_info_suspend_out[] = {NULL};
static const GDBusMethodInfo _quick_settings_system_interface_dbus_method_info_suspend = {-1, "Suspend", (GDBusArgInfo **) (&_quick_settings_system_interface_dbus_arg_info_suspend_in), (GDBusArgInfo **) (&_quick_settings_system_interface_dbus_arg_info_suspend_out), NULL};
static const GDBusArgInfo _quick_settings_system_interface_dbus_arg_info_reboot_interactive = {-1, "interactive", "b", NULL};
static const GDBusArgInfo * const _quick_settings_system_interface_dbus_arg_info_reboot_in[] = {&_quick_settings_system_interface_dbus_arg_info_reboot_interactive, NULL};
static const GDBusArgInfo * const _quick_settings_system_interface_dbus_arg_info_reboot_out[] = {NULL};
static const GDBusMethodInfo _quick_settings_system_interface_dbus_method_info_reboot = {-1, "Reboot", (GDBusArgInfo **) (&_quick_settings_system_interface_dbus_arg_info_reboot_in), (GDBusArgInfo **) (&_quick_settings_system_interface_dbus_arg_info_reboot_out), NULL};
static const GDBusArgInfo _quick_settings_system_interface_dbus_arg_info_power_off_interactive = {-1, "interactive", "b", NULL};
static const GDBusArgInfo * const _quick_settings_system_interface_dbus_arg_info_power_off_in[] = {&_quick_settings_system_interface_dbus_arg_info_power_off_interactive, NULL};
static const GDBusArgInfo * const _quick_settings_system_interface_dbus_arg_info_power_off_out[] = {NULL};
static const GDBusMethodInfo _quick_settings_system_interface_dbus_method_info_power_off = {-1, "PowerOff", (GDBusArgInfo **) (&_quick_settings_system_interface_dbus_arg_info_power_off_in), (GDBusArgInfo **) (&_quick_settings_system_interface_dbus_arg_info_power_off_out), NULL};
static const GDBusArgInfo _quick_settings_system_interface_dbus_arg_info_reboot_with_flags_flags = {-1, "flags", "t", NULL};
static const GDBusArgInfo * const _quick_settings_system_interface_dbus_arg_info_reboot_with_flags_in[] = {&_quick_settings_system_interface_dbus_arg_info_reboot_with_flags_flags, NULL};
static const GDBusArgInfo * const _quick_settings_system_interface_dbus_arg_info_reboot_with_flags_out[] = {NULL};
static const GDBusMethodInfo _quick_settings_system_interface_dbus_method_info_reboot_with_flags = {-1, "RebootWithFlags", (GDBusArgInfo **) (&_quick_settings_system_interface_dbus_arg_info_reboot_with_flags_in), (GDBusArgInfo **) (&_quick_settings_system_interface_dbus_arg_info_reboot_with_flags_out), NULL};
static const GDBusArgInfo _quick_settings_system_interface_dbus_arg_info_power_off_with_flags_flags = {-1, "flags", "t", NULL};
static const GDBusArgInfo * const _quick_settings_system_interface_dbus_arg_info_power_off_with_flags_in[] = {&_quick_settings_system_interface_dbus_arg_info_power_off_with_flags_flags, NULL};
static const GDBusArgInfo * const _quick_settings_system_interface_dbus_arg_info_power_off_with_flags_out[] = {NULL};
static const GDBusMethodInfo _quick_settings_system_interface_dbus_method_info_power_off_with_flags = {-1, "PowerOffWithFlags", (GDBusArgInfo **) (&_quick_settings_system_interface_dbus_arg_info_power_off_with_flags_in), (GDBusArgInfo **) (&_quick_settings_system_interface_dbus_arg_info_power_off_with_flags_out), NULL};
static const GDBusArgInfo _quick_settings_system_interface_dbus_arg_info_list_users_result = {-1, "result", "a(uso)", NULL};
static const GDBusArgInfo * const _quick_settings_system_interface_dbus_arg_info_list_users_in[] = {NULL};
static const GDBusArgInfo * const _quick_settings_system_interface_dbus_arg_info_list_users_out[] = {&_quick_settings_system_interface_dbus_arg_info_list_users_result, NULL};
static const GDBusMethodInfo _quick_settings_system_interface_dbus_method_info_list_users = {-1, "ListUsers", (GDBusArgInfo **) (&_quick_settings_system_interface_dbus_arg_info_list_users_in), (GDBusArgInfo **) (&_quick_settings_system_interface_dbus_arg_info_list_users_out), NULL};
static const GDBusArgInfo _quick_settings_system_interface_dbus_arg_info_can_suspend_result = {-1, "result", "s", NULL};
static const GDBusArgInfo * const _quick_settings_system_interface_dbus_arg_info_can_suspend_in[] = {NULL};
static const GDBusArgInfo * const _quick_settings_system_interface_dbus_arg_info_can_suspend_out[] = {&_quick_settings_system_interface_dbus_arg_info_can_suspend_result, NULL};
static const GDBusMethodInfo _quick_settings_system_interface_dbus_method_info_can_suspend = {-1, "CanSuspend", (GDBusArgInfo **) (&_quick_settings_system_interface_dbus_arg_info_can_suspend_in), (GDBusArgInfo **) (&_quick_settings_system_interface_dbus_arg_info_can_suspend_out), NULL};
static const GDBusMethodInfo * const _quick_settings_system_interface_dbus_method_info[] = {&_quick_settings_system_interface_dbus_method_info_suspend, &_quick_settings_system_interface_dbus_method_info_reboot, &_quick_settings_system_interface_dbus_method_info_power_off, &_quick_settings_system_interface_dbus_method_info_reboot_with_flags, &_quick_settings_system_interface_dbus_method_info_power_off_with_flags, &_quick_settings_system_interface_dbus_method_info_list_users, &_quick_settings_system_interface_dbus_method_info_can_suspend, NULL};
static const GDBusSignalInfo * const _quick_settings_system_interface_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo * const _quick_settings_system_interface_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _quick_settings_system_interface_dbus_interface_info = {-1, "org.freedesktop.login1.Manager", (GDBusMethodInfo **) (&_quick_settings_system_interface_dbus_method_info), (GDBusSignalInfo **) (&_quick_settings_system_interface_dbus_signal_info), (GDBusPropertyInfo **) (&_quick_settings_system_interface_dbus_property_info), NULL};
static const GDBusInterfaceVTable _quick_settings_system_interface_dbus_interface_vtable = {quick_settings_system_interface_dbus_interface_method_call, quick_settings_system_interface_dbus_interface_get_property, quick_settings_system_interface_dbus_interface_set_property};

void
user_info_copy (const UserInfo* self,
                UserInfo* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const char* _tmp2_;
	char* _tmp3_;
	(*dest).uid = (*self).uid;
	_tmp0_ = (*self).user_name;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).user_name);
	(*dest).user_name = _tmp1_;
	_tmp2_ = (*self).user_object;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).user_object);
	(*dest).user_object = _tmp3_;
}

void
user_info_destroy (UserInfo* self)
{
	_g_free0 ((*self).user_name);
	_g_free0 ((*self).user_object);
}

UserInfo*
user_info_dup (const UserInfo* self)
{
	UserInfo* dup;
	dup = g_new0 (UserInfo, 1);
	user_info_copy (self, dup);
	return dup;
}

void
user_info_free (UserInfo* self)
{
	user_info_destroy (self);
	g_free (self);
}

static GType
user_info_get_type_once (void)
{
	GType user_info_type_id;
	user_info_type_id = g_boxed_type_register_static ("UserInfo", (GBoxedCopyFunc) user_info_dup, (GBoxedFreeFunc) user_info_free);
	return user_info_type_id;
}

GType
user_info_get_type (void)
{
	static volatile gsize user_info_type_id__once = 0;
	if (g_once_init_enter (&user_info_type_id__once)) {
		GType user_info_type_id;
		user_info_type_id = user_info_get_type_once ();
		g_once_init_leave (&user_info_type_id__once, user_info_type_id);
	}
	return user_info_type_id__once;
}

void
quick_settings_system_interface_suspend (QuickSettingsSystemInterface* self,
                                         gboolean interactive,
                                         GError** error)
{
	QuickSettingsSystemInterfaceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = QUICK_SETTINGS_SYSTEM_INTERFACE_GET_INTERFACE (self);
	if (_iface_->suspend) {
		_iface_->suspend (self, interactive, error);
	}
}

void
quick_settings_system_interface_reboot (QuickSettingsSystemInterface* self,
                                        gboolean interactive,
                                        GError** error)
{
	QuickSettingsSystemInterfaceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = QUICK_SETTINGS_SYSTEM_INTERFACE_GET_INTERFACE (self);
	if (_iface_->reboot) {
		_iface_->reboot (self, interactive, error);
	}
}

void
quick_settings_system_interface_power_off (QuickSettingsSystemInterface* self,
                                           gboolean interactive,
                                           GError** error)
{
	QuickSettingsSystemInterfaceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = QUICK_SETTINGS_SYSTEM_INTERFACE_GET_INTERFACE (self);
	if (_iface_->power_off) {
		_iface_->power_off (self, interactive, error);
	}
}

void
quick_settings_system_interface_reboot_with_flags (QuickSettingsSystemInterface* self,
                                                   guint64 flags,
                                                   GError** error)
{
	QuickSettingsSystemInterfaceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = QUICK_SETTINGS_SYSTEM_INTERFACE_GET_INTERFACE (self);
	if (_iface_->reboot_with_flags) {
		_iface_->reboot_with_flags (self, flags, error);
	}
}

void
quick_settings_system_interface_power_off_with_flags (QuickSettingsSystemInterface* self,
                                                      guint64 flags,
                                                      GError** error)
{
	QuickSettingsSystemInterfaceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = QUICK_SETTINGS_SYSTEM_INTERFACE_GET_INTERFACE (self);
	if (_iface_->power_off_with_flags) {
		_iface_->power_off_with_flags (self, flags, error);
	}
}

UserInfo*
quick_settings_system_interface_list_users (QuickSettingsSystemInterface* self,
                                            gint* result_length1,
                                            GError** error)
{
	QuickSettingsSystemInterfaceIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = QUICK_SETTINGS_SYSTEM_INTERFACE_GET_INTERFACE (self);
	if (_iface_->list_users) {
		return _iface_->list_users (self, result_length1, error);
	}
	return NULL;
}

gchar*
quick_settings_system_interface_can_suspend (QuickSettingsSystemInterface* self,
                                             GError** error)
{
	QuickSettingsSystemInterfaceIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = QUICK_SETTINGS_SYSTEM_INTERFACE_GET_INTERFACE (self);
	if (_iface_->can_suspend) {
		return _iface_->can_suspend (self, error);
	}
	return NULL;
}

static void
quick_settings_system_interface_default_init (QuickSettingsSystemInterfaceIface * iface,
                                              gpointer iface_data)
{
}

static GType
quick_settings_system_interface_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (QuickSettingsSystemInterfaceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) quick_settings_system_interface_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType quick_settings_system_interface_type_id;
	quick_settings_system_interface_type_id = g_type_register_static (G_TYPE_INTERFACE, "QuickSettingsSystemInterface", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (quick_settings_system_interface_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (quick_settings_system_interface_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) quick_settings_system_interface_proxy_get_type);
	g_type_set_qdata (quick_settings_system_interface_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.freedesktop.login1.Manager");
	g_type_set_qdata (quick_settings_system_interface_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_quick_settings_system_interface_dbus_interface_info));
	g_type_set_qdata (quick_settings_system_interface_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) quick_settings_system_interface_register_object);
	return quick_settings_system_interface_type_id;
}

GType
quick_settings_system_interface_get_type (void)
{
	static volatile gsize quick_settings_system_interface_type_id__once = 0;
	if (g_once_init_enter (&quick_settings_system_interface_type_id__once)) {
		GType quick_settings_system_interface_type_id;
		quick_settings_system_interface_type_id = quick_settings_system_interface_get_type_once ();
		g_once_init_leave (&quick_settings_system_interface_type_id__once, quick_settings_system_interface_type_id);
	}
	return quick_settings_system_interface_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (QuickSettingsSystemInterfaceProxy, quick_settings_system_interface_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (QUICK_SETTINGS_TYPE_SYSTEM_INTERFACE, quick_settings_system_interface_proxy_quick_settings_system_interface_interface_init) )
static void
quick_settings_system_interface_proxy_class_init (QuickSettingsSystemInterfaceProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = quick_settings_system_interface_proxy_g_signal;
}

static void
quick_settings_system_interface_proxy_g_signal (GDBusProxy* proxy,
                                                const gchar* sender_name,
                                                const gchar* signal_name,
                                                GVariant* parameters)
{
}

static void
quick_settings_system_interface_proxy_init (QuickSettingsSystemInterfaceProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_quick_settings_system_interface_dbus_interface_info));
}

static void
quick_settings_system_interface_proxy_suspend (QuickSettingsSystemInterface* self,
                                               gboolean interactive,
                                               GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.freedesktop.login1.Manager", "Suspend");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (interactive));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
quick_settings_system_interface_proxy_reboot (QuickSettingsSystemInterface* self,
                                              gboolean interactive,
                                              GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.freedesktop.login1.Manager", "Reboot");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (interactive));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
quick_settings_system_interface_proxy_power_off (QuickSettingsSystemInterface* self,
                                                 gboolean interactive,
                                                 GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.freedesktop.login1.Manager", "PowerOff");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (interactive));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
quick_settings_system_interface_proxy_reboot_with_flags (QuickSettingsSystemInterface* self,
                                                         guint64 flags,
                                                         GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.freedesktop.login1.Manager", "RebootWithFlags");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint64 (flags));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
quick_settings_system_interface_proxy_power_off_with_flags (QuickSettingsSystemInterface* self,
                                                            guint64 flags,
                                                            GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.freedesktop.login1.Manager", "PowerOffWithFlags");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint64 (flags));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static UserInfo*
quick_settings_system_interface_proxy_list_users (QuickSettingsSystemInterface* self,
                                                  gint* result_length1,
                                                  GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	UserInfo* _result = NULL;
	gint _result_length1;
	GVariant* _tmp13_;
	UserInfo* _tmp14_;
	gint _tmp14__length;
	gint _tmp14__size;
	gint _tmp14__length1;
	GVariantIter _tmp15_;
	GVariant* _tmp16_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.freedesktop.login1.Manager", "ListUsers");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_result_length1 = 0;
	_tmp13_ = g_variant_iter_next_value (&_reply_iter);
	_tmp14_ = g_new (UserInfo, 5);
	_tmp14__length = 0;
	_tmp14__size = 4;
	_tmp14__length1 = 0;
	g_variant_iter_init (&_tmp15_, _tmp13_);
	for (; (_tmp16_ = g_variant_iter_next_value (&_tmp15_)) != NULL; _tmp14__length1++) {
		UserInfo _tmp17_;
		GVariantIter _tmp18_;
		GVariant* _tmp19_;
		GVariant* _tmp20_;
		GVariant* _tmp21_;
		if (_tmp14__size == _tmp14__length) {
			_tmp14__size = 2 * _tmp14__size;
			_tmp14_ = g_renew (UserInfo, _tmp14_, _tmp14__size + 1);
		}
		g_variant_iter_init (&_tmp18_, _tmp16_);
		_tmp19_ = g_variant_iter_next_value (&_tmp18_);
		_tmp17_.uid = g_variant_get_uint32 (_tmp19_);
		g_variant_unref (_tmp19_);
		_tmp20_ = g_variant_iter_next_value (&_tmp18_);
		_tmp17_.user_name = g_variant_dup_string (_tmp20_, NULL);
		g_variant_unref (_tmp20_);
		_tmp21_ = g_variant_iter_next_value (&_tmp18_);
		_tmp17_.user_object = g_variant_dup_string (_tmp21_, NULL);
		g_variant_unref (_tmp21_);
		_tmp14_[_tmp14__length++] = _tmp17_;
		g_variant_unref (_tmp16_);
	}
	_result_length1 = _tmp14__length1;
	_result = _tmp14_;
	g_variant_unref (_tmp13_);
	*result_length1 = _result_length1;
	g_object_unref (_reply_message);
	return _result;
}

static gchar*
quick_settings_system_interface_proxy_can_suspend (QuickSettingsSystemInterface* self,
                                                   GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result = NULL;
	GVariant* _tmp22_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.freedesktop.login1.Manager", "CanSuspend");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp22_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp22_, NULL);
	g_variant_unref (_tmp22_);
	g_object_unref (_reply_message);
	return _result;
}

static void
quick_settings_system_interface_proxy_quick_settings_system_interface_interface_init (QuickSettingsSystemInterfaceIface* iface)
{
	iface->suspend = quick_settings_system_interface_proxy_suspend;
	iface->reboot = quick_settings_system_interface_proxy_reboot;
	iface->power_off = quick_settings_system_interface_proxy_power_off;
	iface->reboot_with_flags = quick_settings_system_interface_proxy_reboot_with_flags;
	iface->power_off_with_flags = quick_settings_system_interface_proxy_power_off_with_flags;
	iface->list_users = quick_settings_system_interface_proxy_list_users;
	iface->can_suspend = quick_settings_system_interface_proxy_can_suspend;
}

static void
_dbus_quick_settings_system_interface_suspend (QuickSettingsSystemInterface* self,
                                               GVariant* _parameters_,
                                               GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gboolean interactive = FALSE;
	GVariant* _tmp23_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp23_ = g_variant_iter_next_value (&_arguments_iter);
	interactive = g_variant_get_boolean (_tmp23_);
	g_variant_unref (_tmp23_);
	quick_settings_system_interface_suspend (self, interactive, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_quick_settings_system_interface_reboot (QuickSettingsSystemInterface* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gboolean interactive = FALSE;
	GVariant* _tmp24_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp24_ = g_variant_iter_next_value (&_arguments_iter);
	interactive = g_variant_get_boolean (_tmp24_);
	g_variant_unref (_tmp24_);
	quick_settings_system_interface_reboot (self, interactive, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_quick_settings_system_interface_power_off (QuickSettingsSystemInterface* self,
                                                 GVariant* _parameters_,
                                                 GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gboolean interactive = FALSE;
	GVariant* _tmp25_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp25_ = g_variant_iter_next_value (&_arguments_iter);
	interactive = g_variant_get_boolean (_tmp25_);
	g_variant_unref (_tmp25_);
	quick_settings_system_interface_power_off (self, interactive, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_quick_settings_system_interface_reboot_with_flags (QuickSettingsSystemInterface* self,
                                                         GVariant* _parameters_,
                                                         GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint64 flags = 0ULL;
	GVariant* _tmp26_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp26_ = g_variant_iter_next_value (&_arguments_iter);
	flags = g_variant_get_uint64 (_tmp26_);
	g_variant_unref (_tmp26_);
	quick_settings_system_interface_reboot_with_flags (self, flags, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_quick_settings_system_interface_power_off_with_flags (QuickSettingsSystemInterface* self,
                                                            GVariant* _parameters_,
                                                            GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint64 flags = 0ULL;
	GVariant* _tmp27_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp27_ = g_variant_iter_next_value (&_arguments_iter);
	flags = g_variant_get_uint64 (_tmp27_);
	g_variant_unref (_tmp27_);
	quick_settings_system_interface_power_off_with_flags (self, flags, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_vala_UserInfo_array_free (UserInfo * array,
                           gssize array_length)
{
	if (array != NULL) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			user_info_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
_dbus_quick_settings_system_interface_list_users (QuickSettingsSystemInterface* self,
                                                  GVariant* _parameters_,
                                                  GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	UserInfo* result;
	gint result_length1 = 0;
	UserInfo* _tmp28_;
	GVariantBuilder _tmp29_;
	gint _tmp30_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = quick_settings_system_interface_list_users (self, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp28_ = result;
	g_variant_builder_init (&_tmp29_, G_VARIANT_TYPE ("a(uso)"));
	for (_tmp30_ = 0; _tmp30_ < result_length1; _tmp30_++) {
		GVariantBuilder _tmp31_;
		g_variant_builder_init (&_tmp31_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp31_, g_variant_new_uint32 ((*_tmp28_).uid));
		g_variant_builder_add_value (&_tmp31_, g_variant_new_string ((*_tmp28_).user_name));
		g_variant_builder_add_value (&_tmp31_, g_variant_new_object_path ((*_tmp28_).user_object));
		g_variant_builder_add_value (&_tmp29_, g_variant_builder_end (&_tmp31_));
		_tmp28_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp29_));
	result = (_vala_UserInfo_array_free (result, result_length1), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_quick_settings_system_interface_can_suspend (QuickSettingsSystemInterface* self,
                                                   GVariant* _parameters_,
                                                   GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = quick_settings_system_interface_can_suspend (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
quick_settings_system_interface_dbus_interface_method_call (GDBusConnection* connection,
                                                            const gchar* sender,
                                                            const gchar* object_path,
                                                            const gchar* interface_name,
                                                            const gchar* method_name,
                                                            GVariant* parameters,
                                                            GDBusMethodInvocation* invocation,
                                                            gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Suspend") == 0) {
		_dbus_quick_settings_system_interface_suspend (object, parameters, invocation);
	} else if (strcmp (method_name, "Reboot") == 0) {
		_dbus_quick_settings_system_interface_reboot (object, parameters, invocation);
	} else if (strcmp (method_name, "PowerOff") == 0) {
		_dbus_quick_settings_system_interface_power_off (object, parameters, invocation);
	} else if (strcmp (method_name, "RebootWithFlags") == 0) {
		_dbus_quick_settings_system_interface_reboot_with_flags (object, parameters, invocation);
	} else if (strcmp (method_name, "PowerOffWithFlags") == 0) {
		_dbus_quick_settings_system_interface_power_off_with_flags (object, parameters, invocation);
	} else if (strcmp (method_name, "ListUsers") == 0) {
		_dbus_quick_settings_system_interface_list_users (object, parameters, invocation);
	} else if (strcmp (method_name, "CanSuspend") == 0) {
		_dbus_quick_settings_system_interface_can_suspend (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
quick_settings_system_interface_dbus_interface_get_property (GDBusConnection* connection,
                                                             const gchar* sender,
                                                             const gchar* object_path,
                                                             const gchar* interface_name,
                                                             const gchar* property_name,
                                                             GError** error,
                                                             gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
quick_settings_system_interface_dbus_interface_set_property (GDBusConnection* connection,
                                                             const gchar* sender,
                                                             const gchar* object_path,
                                                             const gchar* interface_name,
                                                             const gchar* property_name,
                                                             GVariant* value,
                                                             GError** error,
                                                             gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

guint
quick_settings_system_interface_register_object (gpointer object,
                                                 GDBusConnection* connection,
                                                 const gchar* path,
                                                 GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_quick_settings_system_interface_dbus_interface_info), &_quick_settings_system_interface_dbus_interface_vtable, data, _quick_settings_system_interface_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}

static void
_quick_settings_system_interface_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

