/* Indicator.c generated by valac 0.56.18, the Vala compiler
 * generated from Indicator.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2023 elementary, Inc. (https://elementary.io)
 */

#include "quick-settings.h"
#include <wingpanel.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <gmodule.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	QUICK_SETTINGS_INDICATOR_0_PROPERTY,
	QUICK_SETTINGS_INDICATOR_SERVER_TYPE_PROPERTY,
	QUICK_SETTINGS_INDICATOR_NUM_PROPERTIES
};
static GParamSpec* quick_settings_indicator_properties[QUICK_SETTINGS_INDICATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _QuickSettingsIndicatorPrivate {
	WingpanelIndicatorManagerServerType _server_type;
	QuickSettingsPopoverWidget* popover_widget;
};

static gint QuickSettingsIndicator_private_offset;
static gpointer quick_settings_indicator_parent_class = NULL;

static GtkWidget* quick_settings_indicator_real_get_display_widget (WingpanelIndicator* base);
static GtkWidget* quick_settings_indicator_real_get_widget (WingpanelIndicator* base);
static void quick_settings_indicator_real_opened (WingpanelIndicator* base);
static void quick_settings_indicator_real_closed (WingpanelIndicator* base);
static GObject * quick_settings_indicator_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void quick_settings_indicator_finalize (GObject * obj);
static GType quick_settings_indicator_get_type_once (void);
static void _vala_quick_settings_indicator_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_quick_settings_indicator_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);

static inline gpointer
quick_settings_indicator_get_instance_private (QuickSettingsIndicator* self)
{
	return G_STRUCT_MEMBER_P (self, QuickSettingsIndicator_private_offset);
}

QuickSettingsIndicator*
quick_settings_indicator_construct (GType object_type,
                                    WingpanelIndicatorManagerServerType server_type)
{
	QuickSettingsIndicator * self = NULL;
	self = (QuickSettingsIndicator*) g_object_new (object_type, "code-name", "quick-settings", "server-type", server_type, "visible", TRUE, NULL);
	return self;
}

QuickSettingsIndicator*
quick_settings_indicator_new (WingpanelIndicatorManagerServerType server_type)
{
	return quick_settings_indicator_construct (QUICK_SETTINGS_TYPE_INDICATOR, server_type);
}

static GtkWidget*
quick_settings_indicator_real_get_display_widget (WingpanelIndicator* base)
{
	QuickSettingsIndicator * self;
	GtkImage* indicator_icon = NULL;
	gchar* _tmp0_;
	GtkImage* _tmp1_ = NULL;
	GtkWidget* result;
	self = (QuickSettingsIndicator*) base;
	_tmp0_ = g_strdup ("quick-settings-symbolic");
	_tmp1_ = (GtkImage*) gtk_image_new ();
	g_object_set (_tmp1_, "icon-name", _tmp0_, NULL);
	_g_free0 (_tmp0_);
	gtk_image_set_pixel_size (_tmp1_, 24);
	g_object_ref_sink (_tmp1_);
	indicator_icon = _tmp1_;
	result = (GtkWidget*) indicator_icon;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static GtkWidget*
quick_settings_indicator_real_get_widget (WingpanelIndicator* base)
{
	QuickSettingsIndicator * self;
	QuickSettingsPopoverWidget* _tmp0_;
	QuickSettingsPopoverWidget* _tmp7_;
	GtkWidget* _tmp8_;
	GtkWidget* result;
	self = (QuickSettingsIndicator*) base;
	_tmp0_ = self->priv->popover_widget;
	if (_tmp0_ == NULL) {
		GtkCssProvider* provider = NULL;
		GtkCssProvider* _tmp1_;
		GtkCssProvider* _tmp2_;
		GdkScreen* _tmp3_;
		GtkCssProvider* _tmp4_;
		WingpanelIndicatorManagerServerType _tmp5_;
		QuickSettingsPopoverWidget* _tmp6_;
		_tmp1_ = gtk_css_provider_new ();
		provider = _tmp1_;
		_tmp2_ = provider;
		gtk_css_provider_load_from_resource (_tmp2_, "io/elementary/quick-settings/Indicator.css");
		_tmp3_ = gdk_screen_get_default ();
		_tmp4_ = provider;
		gtk_style_context_add_provider_for_screen (_tmp3_, (GtkStyleProvider*) _tmp4_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
		_tmp5_ = self->priv->_server_type;
		_tmp6_ = quick_settings_popover_widget_new (_tmp5_);
		g_object_ref_sink (_tmp6_);
		_g_object_unref0 (self->priv->popover_widget);
		self->priv->popover_widget = _tmp6_;
		_g_object_unref0 (provider);
	}
	_tmp7_ = self->priv->popover_widget;
	_tmp8_ = _g_object_ref0 ((GtkWidget*) _tmp7_);
	result = _tmp8_;
	return result;
}

static void
quick_settings_indicator_real_opened (WingpanelIndicator* base)
{
	QuickSettingsIndicator * self;
	QuickSettingsPopoverWidget* _tmp0_;
	QuickSettingsPopoverWidget* _tmp1_;
	self = (QuickSettingsIndicator*) base;
	_tmp0_ = self->priv->popover_widget;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp1_ = self->priv->popover_widget;
	quick_settings_popover_widget_update_user_tooltip (_tmp1_, NULL, NULL);
}

static void
quick_settings_indicator_real_closed (WingpanelIndicator* base)
{
	QuickSettingsIndicator * self;
	QuickSettingsPopoverWidget* _tmp0_;
	QuickSettingsPopoverWidget* _tmp1_;
	self = (QuickSettingsIndicator*) base;
	_tmp0_ = self->priv->popover_widget;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp1_ = self->priv->popover_widget;
	quick_settings_popover_widget_reset_stack (_tmp1_);
}

WingpanelIndicatorManagerServerType
quick_settings_indicator_get_server_type (QuickSettingsIndicator* self)
{
	WingpanelIndicatorManagerServerType result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_server_type;
	return result;
}

static void
quick_settings_indicator_set_server_type (QuickSettingsIndicator* self,
                                          WingpanelIndicatorManagerServerType value)
{
	WingpanelIndicatorManagerServerType old_value;
	g_return_if_fail (self != NULL);
	old_value = quick_settings_indicator_get_server_type (self);
	if (old_value != value) {
		self->priv->_server_type = value;
		g_object_notify_by_pspec ((GObject *) self, quick_settings_indicator_properties[QUICK_SETTINGS_INDICATOR_SERVER_TYPE_PROPERTY]);
	}
}

static GObject *
quick_settings_indicator_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	QuickSettingsIndicator * self;
	GtkIconTheme* _tmp0_;
	parent_class = G_OBJECT_CLASS (quick_settings_indicator_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, QUICK_SETTINGS_TYPE_INDICATOR, QuickSettingsIndicator);
	bindtextdomain (CONSTANTS_GETTEXT_PACKAGE, CONSTANTS_LOCALEDIR);
	bind_textdomain_codeset (CONSTANTS_GETTEXT_PACKAGE, "UTF-8");
	_tmp0_ = gtk_icon_theme_get_default ();
	gtk_icon_theme_add_resource_path (_tmp0_, "/org/elementary/wingpanel/icons");
	return obj;
}

static void
quick_settings_indicator_class_init (QuickSettingsIndicatorClass * klass,
                                     gpointer klass_data)
{
	quick_settings_indicator_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &QuickSettingsIndicator_private_offset);
	((WingpanelIndicatorClass *) klass)->get_display_widget = (GtkWidget* (*) (WingpanelIndicator*)) quick_settings_indicator_real_get_display_widget;
	((WingpanelIndicatorClass *) klass)->get_widget = (GtkWidget* (*) (WingpanelIndicator*)) quick_settings_indicator_real_get_widget;
	((WingpanelIndicatorClass *) klass)->opened = (void (*) (WingpanelIndicator*)) quick_settings_indicator_real_opened;
	((WingpanelIndicatorClass *) klass)->closed = (void (*) (WingpanelIndicator*)) quick_settings_indicator_real_closed;
	G_OBJECT_CLASS (klass)->get_property = _vala_quick_settings_indicator_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_quick_settings_indicator_set_property;
	G_OBJECT_CLASS (klass)->constructor = quick_settings_indicator_constructor;
	G_OBJECT_CLASS (klass)->finalize = quick_settings_indicator_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), QUICK_SETTINGS_INDICATOR_SERVER_TYPE_PROPERTY, quick_settings_indicator_properties[QUICK_SETTINGS_INDICATOR_SERVER_TYPE_PROPERTY] = g_param_spec_enum ("server-type", "server-type", "server-type", WINGPANEL_INDICATOR_MANAGER_TYPE_SERVER_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
quick_settings_indicator_instance_init (QuickSettingsIndicator * self,
                                        gpointer klass)
{
	self->priv = quick_settings_indicator_get_instance_private (self);
}

static void
quick_settings_indicator_finalize (GObject * obj)
{
	QuickSettingsIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, QUICK_SETTINGS_TYPE_INDICATOR, QuickSettingsIndicator);
	_g_object_unref0 (self->priv->popover_widget);
	G_OBJECT_CLASS (quick_settings_indicator_parent_class)->finalize (obj);
}

static GType
quick_settings_indicator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (QuickSettingsIndicatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) quick_settings_indicator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (QuickSettingsIndicator), 0, (GInstanceInitFunc) quick_settings_indicator_instance_init, NULL };
	GType quick_settings_indicator_type_id;
	quick_settings_indicator_type_id = g_type_register_static (WINGPANEL_TYPE_INDICATOR, "QuickSettingsIndicator", &g_define_type_info, 0);
	QuickSettingsIndicator_private_offset = g_type_add_instance_private (quick_settings_indicator_type_id, sizeof (QuickSettingsIndicatorPrivate));
	return quick_settings_indicator_type_id;
}

GType
quick_settings_indicator_get_type (void)
{
	static volatile gsize quick_settings_indicator_type_id__once = 0;
	if (g_once_init_enter (&quick_settings_indicator_type_id__once)) {
		GType quick_settings_indicator_type_id;
		quick_settings_indicator_type_id = quick_settings_indicator_get_type_once ();
		g_once_init_leave (&quick_settings_indicator_type_id__once, quick_settings_indicator_type_id);
	}
	return quick_settings_indicator_type_id__once;
}

static void
_vala_quick_settings_indicator_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	QuickSettingsIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, QUICK_SETTINGS_TYPE_INDICATOR, QuickSettingsIndicator);
	switch (property_id) {
		case QUICK_SETTINGS_INDICATOR_SERVER_TYPE_PROPERTY:
		g_value_set_enum (value, quick_settings_indicator_get_server_type (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_quick_settings_indicator_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	QuickSettingsIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, QUICK_SETTINGS_TYPE_INDICATOR, QuickSettingsIndicator);
	switch (property_id) {
		case QUICK_SETTINGS_INDICATOR_SERVER_TYPE_PROPERTY:
		quick_settings_indicator_set_server_type (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

WingpanelIndicator*
get_indicator (GModule* module,
               WingpanelIndicatorManagerServerType server_type)
{
	QuickSettingsIndicator* _tmp0_;
	WingpanelIndicator* result;
	g_return_val_if_fail (module != NULL, NULL);
	_tmp0_ = quick_settings_indicator_new (server_type);
	result = (WingpanelIndicator*) _tmp0_;
	return result;
}

