/* PopoverWidget.c generated by valac 0.56.18, the Vala compiler
 * generated from PopoverWidget.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2023 elementary, Inc. (https://elementary.io)
 */

#include "quick-settings.h"
#include <wingpanel.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

#define QUICK_SETTINGS_POPOVER_WIDGET_FDO_ACCOUNTS_NAME "org.freedesktop.Accounts"
#define QUICK_SETTINGS_POPOVER_WIDGET_FDO_ACCOUNTS_PATH "/org/freedesktop/Accounts"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	QUICK_SETTINGS_POPOVER_WIDGET_0_PROPERTY,
	QUICK_SETTINGS_POPOVER_WIDGET_SERVER_TYPE_PROPERTY,
	QUICK_SETTINGS_POPOVER_WIDGET_NUM_PROPERTIES
};
static GParamSpec* quick_settings_popover_widget_properties[QUICK_SETTINGS_POPOVER_WIDGET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define QUICK_SETTINGS_TYPE_SENSOR_PROXY (quick_settings_sensor_proxy_get_type ())
#define QUICK_SETTINGS_SENSOR_PROXY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), QUICK_SETTINGS_TYPE_SENSOR_PROXY, QuickSettingsSensorProxy))
#define QUICK_SETTINGS_IS_SENSOR_PROXY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), QUICK_SETTINGS_TYPE_SENSOR_PROXY))
#define QUICK_SETTINGS_SENSOR_PROXY_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), QUICK_SETTINGS_TYPE_SENSOR_PROXY, QuickSettingsSensorProxyIface))

typedef struct _QuickSettingsSensorProxy QuickSettingsSensorProxy;
typedef struct _QuickSettingsSensorProxyIface QuickSettingsSensorProxyIface;

#define QUICK_SETTINGS_TYPE_SENSOR_PROXY_PROXY (quick_settings_sensor_proxy_proxy_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _QuickSettingsPopoverWidgetSetupSensorProxyData QuickSettingsPopoverWidgetSetupSensorProxyData;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _QuickSettingsPopoverWidgetUpdateUserTooltipData QuickSettingsPopoverWidgetUpdateUserTooltipData;
typedef struct _Block1Data Block1Data;

struct _QuickSettingsPopoverWidgetPrivate {
	WingpanelIndicatorManagerServerType _server_type;
	GtkPopover* popover;
	GtkStack* stack;
	GtkBox* main_box;
	QuickSettingsUserList* accounts_view;
	GtkButton* current_user_button;
};

struct _QuickSettingsSensorProxyIface {
	GTypeInterface parent_iface;
	gboolean (*get_has_accelerometer) (QuickSettingsSensorProxy* self);
};

struct _QuickSettingsPopoverWidgetSetupSensorProxyData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	QuickSettingsPopoverWidget* self;
	QuickSettingsSensorProxy* result;
	QuickSettingsSensorProxy* _tmp0_;
	QuickSettingsSensorProxy* _tmp1_;
	QuickSettingsSensorProxy* _tmp2_;
	GError* e;
	GError* _tmp3_;
	const gchar* _tmp4_;
	GError* _inner_error0_;
};

struct _QuickSettingsPopoverWidgetUpdateUserTooltipData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	QuickSettingsPopoverWidget* self;
	gboolean _tmp0_;
	WingpanelIndicatorManagerServerType _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
};

struct _Block1Data {
	int _ref_count_;
	QuickSettingsPopoverWidget* self;
	QuickSettingsSettingsToggle* screen_reader;
	QuickSettingsSettingsToggle* onscreen_keyboard;
	GtkFlowBox* toggle_box;
	QuickSettingsTextScale* text_scale;
	GtkBox* scale_box;
	GSettings* glib_settings;
};

static gint QuickSettingsPopoverWidget_private_offset;
static gpointer quick_settings_popover_widget_parent_class = NULL;

static void quick_settings_popover_widget_setup_sensor_proxy_data_free (gpointer _data);
VALA_EXTERN GType quick_settings_sensor_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType quick_settings_sensor_proxy_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint quick_settings_sensor_proxy_register_object (void* object,
                                                   GDBusConnection* connection,
                                                   const gchar* path,
                                                   GError** error);
static void quick_settings_popover_widget_setup_sensor_proxy (QuickSettingsPopoverWidget* self,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_);
static QuickSettingsSensorProxy* quick_settings_popover_widget_setup_sensor_proxy_finish (QuickSettingsPopoverWidget* self,
                                                                                   GAsyncResult* _res_);
static gboolean quick_settings_popover_widget_setup_sensor_proxy_co (QuickSettingsPopoverWidgetSetupSensorProxyData* _data_);
static void quick_settings_popover_widget_setup_sensor_proxy_ready (GObject* source_object,
                                                             GAsyncResult* _res_,
                                                             gpointer _user_data_);
static void quick_settings_popover_widget_update_user_tooltip_data_free (gpointer _data);
static gboolean quick_settings_popover_widget_update_user_tooltip_co (QuickSettingsPopoverWidgetUpdateUserTooltipData* _data_);
static gboolean quick_settings_popover_widget_is_running_in_demo_mode (QuickSettingsPopoverWidget* self);
static void quick_settings_popover_widget_update_user_tooltip_ready (GObject* source_object,
                                                              GAsyncResult* _res_,
                                                              gpointer _user_data_);
static GObject * quick_settings_popover_widget_constructor (GType type,
                                                     guint n_construct_properties,
                                                     GObjectConstructParam * construct_properties);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void _quick_settings_popover_widget___lambda53_ (Block1Data* _data1_,
                                                 GObject* obj,
                                                 GAsyncResult* res);
VALA_EXTERN gboolean quick_settings_sensor_proxy_get_has_accelerometer (QuickSettingsSensorProxy* self);
static void __quick_settings_popover_widget___lambda53__gasync_ready_callback (GObject* source_object,
                                                                        GAsyncResult* res,
                                                                        gpointer self);
static void _quick_settings_popover_widget___lambda55_ (QuickSettingsPopoverWidget* self);
static void __quick_settings_popover_widget___lambda55__gtk_widget_realize (GtkWidget* _sender,
                                                                     gpointer self);
static void _quick_settings_popover_widget___lambda56_ (Block1Data* _data1_);
static void __quick_settings_popover_widget___lambda56__g_settings_changed (GSettings* _sender,
                                                                     const gchar* key,
                                                                     gpointer self);
static void _quick_settings_popover_widget___lambda57_ (QuickSettingsPopoverWidget* self);
static void __quick_settings_popover_widget___lambda57__gtk_button_clicked (GtkButton* _sender,
                                                                     gpointer self);
static void quick_settings_popover_widget_finalize (GObject * obj);
static GType quick_settings_popover_widget_get_type_once (void);
static void _vala_quick_settings_popover_widget_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec);
static void _vala_quick_settings_popover_widget_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec);

static inline gpointer
quick_settings_popover_widget_get_instance_private (QuickSettingsPopoverWidget* self)
{
	return G_STRUCT_MEMBER_P (self, QuickSettingsPopoverWidget_private_offset);
}

QuickSettingsPopoverWidget*
quick_settings_popover_widget_construct (GType object_type,
                                         WingpanelIndicatorManagerServerType server_type)
{
	QuickSettingsPopoverWidget * self = NULL;
	self = (QuickSettingsPopoverWidget*) g_object_new (object_type, "server-type", server_type, NULL);
	return self;
}

QuickSettingsPopoverWidget*
quick_settings_popover_widget_new (WingpanelIndicatorManagerServerType server_type)
{
	return quick_settings_popover_widget_construct (QUICK_SETTINGS_TYPE_POPOVER_WIDGET, server_type);
}

static void
quick_settings_popover_widget_setup_sensor_proxy_data_free (gpointer _data)
{
	QuickSettingsPopoverWidgetSetupSensorProxyData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (QuickSettingsPopoverWidgetSetupSensorProxyData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
quick_settings_popover_widget_setup_sensor_proxy (QuickSettingsPopoverWidget* self,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_)
{
	QuickSettingsPopoverWidgetSetupSensorProxyData* _data_;
	QuickSettingsPopoverWidget* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (QuickSettingsPopoverWidgetSetupSensorProxyData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, quick_settings_popover_widget_setup_sensor_proxy_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	quick_settings_popover_widget_setup_sensor_proxy_co (_data_);
}

static QuickSettingsSensorProxy*
quick_settings_popover_widget_setup_sensor_proxy_finish (QuickSettingsPopoverWidget* self,
                                                         GAsyncResult* _res_)
{
	QuickSettingsSensorProxy* result;
	QuickSettingsPopoverWidgetSetupSensorProxyData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static void
quick_settings_popover_widget_setup_sensor_proxy_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_)
{
	QuickSettingsPopoverWidgetSetupSensorProxyData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	quick_settings_popover_widget_setup_sensor_proxy_co (_data_);
}

static gboolean
quick_settings_popover_widget_setup_sensor_proxy_co (QuickSettingsPopoverWidgetSetupSensorProxyData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	{
		_data_->_state_ = 1;
		g_async_initable_new_async (QUICK_SETTINGS_TYPE_SENSOR_PROXY_PROXY, 0, NULL, quick_settings_popover_widget_setup_sensor_proxy_ready, _data_, "g-flags", 0, "g-name", "net.hadess.SensorProxy", "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", "/net/hadess/SensorProxy", "g-interface-name", "net.hadess.SensorProxy", NULL);
		return FALSE;
		_state_1:
		_data_->_tmp1_ = (QuickSettingsSensorProxy*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
		_data_->_tmp0_ = (QuickSettingsSensorProxy*) _data_->_tmp1_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp2_ = _data_->_tmp0_;
		_data_->_tmp0_ = NULL;
		_data_->result = _data_->_tmp2_;
		_g_object_unref0 (_data_->_tmp0_);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp3_ = _data_->e;
		_data_->_tmp4_ = _data_->_tmp3_->message;
		g_info ("PopoverWidget.vala:155: Unable to connect to SensorProxy bus, probably" \
" means no accelerometer supported: %s", _data_->_tmp4_);
		_data_->result = NULL;
		_g_error_free0 (_data_->e);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
	g_clear_error (&_data_->_inner_error0_);
	g_object_unref (_data_->_async_result);
	return FALSE;
}

void
quick_settings_popover_widget_reset_stack (QuickSettingsPopoverWidget* self)
{
	GtkStack* _tmp0_;
	GtkBox* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->stack;
	_tmp1_ = self->priv->main_box;
	gtk_stack_set_visible_child (_tmp0_, (GtkWidget*) _tmp1_);
}

static void
quick_settings_popover_widget_update_user_tooltip_data_free (gpointer _data)
{
	QuickSettingsPopoverWidgetUpdateUserTooltipData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (QuickSettingsPopoverWidgetUpdateUserTooltipData, _data_);
}

void
quick_settings_popover_widget_update_user_tooltip (QuickSettingsPopoverWidget* self,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_)
{
	QuickSettingsPopoverWidgetUpdateUserTooltipData* _data_;
	QuickSettingsPopoverWidget* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (QuickSettingsPopoverWidgetUpdateUserTooltipData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, quick_settings_popover_widget_update_user_tooltip_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	quick_settings_popover_widget_update_user_tooltip_co (_data_);
}

void
quick_settings_popover_widget_update_user_tooltip_finish (QuickSettingsPopoverWidget* self,
                                                          GAsyncResult* _res_)
{
	QuickSettingsPopoverWidgetUpdateUserTooltipData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
quick_settings_popover_widget_update_user_tooltip_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_)
{
	QuickSettingsPopoverWidgetUpdateUserTooltipData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	quick_settings_popover_widget_update_user_tooltip_co (_data_);
}

static gboolean
quick_settings_popover_widget_update_user_tooltip_co (QuickSettingsPopoverWidgetUpdateUserTooltipData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp1_ = _data_->self->priv->_server_type;
	if (_data_->_tmp1_ != WINGPANEL_INDICATOR_MANAGER_SERVER_TYPE_SESSION) {
		_data_->_tmp0_ = TRUE;
	} else {
		_data_->_tmp0_ = quick_settings_popover_widget_is_running_in_demo_mode (_data_->self);
	}
	if (_data_->_tmp0_) {
		_data_->_tmp2_ = _data_->self->priv->current_user_button;
		gtk_widget_set_tooltip_text ((GtkWidget*) _data_->_tmp2_, _ ("Not logged in"));
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp3_ = _data_->self->priv->current_user_button;
	_data_->_state_ = 1;
	quick_settings_user_manager_get_loggedin_tooltip_markup (quick_settings_popover_widget_update_user_tooltip_ready, _data_);
	return FALSE;
	_state_1:
	_data_->_tmp4_ = quick_settings_user_manager_get_loggedin_tooltip_markup_finish (_data_->_res_);
	_data_->_tmp5_ = _data_->_tmp4_;
	gtk_widget_set_tooltip_markup ((GtkWidget*) _data_->_tmp3_, _data_->_tmp5_);
	_g_free0 (_data_->_tmp5_);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static gboolean
quick_settings_popover_widget_is_running_in_demo_mode (QuickSettingsPopoverWidget* self)
{
	GFile* proc_cmdline = NULL;
	GFile* _tmp0_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = g_file_new_for_path ("/proc/cmdline");
	proc_cmdline = _tmp0_;
	{
		GFileInputStream* is = NULL;
		GFile* _tmp1_;
		GFileInputStream* _tmp2_;
		GDataInputStream* dis = NULL;
		GFileInputStream* _tmp3_;
		GDataInputStream* _tmp4_;
		gchar* line = NULL;
		GDataInputStream* _tmp5_;
		gchar* _tmp6_;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
		const gchar* _tmp9_;
		_tmp1_ = proc_cmdline;
		_tmp2_ = g_file_read (_tmp1_, NULL, &_inner_error0_);
		is = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp3_ = is;
		_tmp4_ = g_data_input_stream_new ((GInputStream*) _tmp3_);
		dis = _tmp4_;
		_tmp5_ = dis;
		_tmp6_ = g_data_input_stream_read_line (_tmp5_, NULL, NULL, &_inner_error0_);
		line = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (dis);
			_g_object_unref0 (is);
			goto __catch0_g_error;
		}
		_tmp9_ = line;
		if (string_contains (_tmp9_, "boot=casper")) {
			_tmp8_ = TRUE;
		} else {
			const gchar* _tmp10_;
			_tmp10_ = line;
			_tmp8_ = string_contains (_tmp10_, "boot=live");
		}
		if (_tmp8_) {
			_tmp7_ = TRUE;
		} else {
			const gchar* _tmp11_;
			_tmp11_ = line;
			_tmp7_ = string_contains (_tmp11_, "rd.live.image");
		}
		if (_tmp7_) {
			result = TRUE;
			_g_free0 (line);
			_g_object_unref0 (dis);
			_g_object_unref0 (is);
			_g_object_unref0 (proc_cmdline);
			return result;
		}
		_g_free0 (line);
		_g_object_unref0 (dis);
		_g_object_unref0 (is);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp12_ = e;
		_tmp13_ = _tmp12_->message;
		g_critical ("PopoverWidget.vala:184: Couldn't detect if running in Demo Mode: %s", _tmp13_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp14_ = FALSE;
		_g_object_unref0 (proc_cmdline);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp14_;
	}
	result = FALSE;
	_g_object_unref0 (proc_cmdline);
	return result;
}

WingpanelIndicatorManagerServerType
quick_settings_popover_widget_get_server_type (QuickSettingsPopoverWidget* self)
{
	WingpanelIndicatorManagerServerType result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_server_type;
	return result;
}

static void
quick_settings_popover_widget_set_server_type (QuickSettingsPopoverWidget* self,
                                               WingpanelIndicatorManagerServerType value)
{
	WingpanelIndicatorManagerServerType old_value;
	g_return_if_fail (self != NULL);
	old_value = quick_settings_popover_widget_get_server_type (self);
	if (old_value != value) {
		self->priv->_server_type = value;
		g_object_notify_by_pspec ((GObject *) self, quick_settings_popover_widget_properties[QUICK_SETTINGS_POPOVER_WIDGET_SERVER_TYPE_PROPERTY]);
	}
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		QuickSettingsPopoverWidget* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->glib_settings);
		_g_object_unref0 (_data1_->scale_box);
		_g_object_unref0 (_data1_->text_scale);
		_g_object_unref0 (_data1_->toggle_box);
		_g_object_unref0 (_data1_->onscreen_keyboard);
		_g_object_unref0 (_data1_->screen_reader);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static void
_quick_settings_popover_widget___lambda53_ (Block1Data* _data1_,
                                            GObject* obj,
                                            GAsyncResult* res)
{
	QuickSettingsPopoverWidget* self;
	QuickSettingsSensorProxy* sensor_proxy = NULL;
	QuickSettingsSensorProxy* _tmp0_;
	QuickSettingsSensorProxy* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	self = _data1_->self;
	g_return_if_fail (res != NULL);
	_tmp0_ = quick_settings_popover_widget_setup_sensor_proxy_finish (self, res);
	sensor_proxy = _tmp0_;
	_tmp1_ = sensor_proxy;
	_tmp2_ = quick_settings_sensor_proxy_get_has_accelerometer (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		QuickSettingsRotationToggle* rotation_toggle = NULL;
		QuickSettingsRotationToggle* _tmp4_;
		GtkFlowBox* _tmp5_;
		QuickSettingsRotationToggle* _tmp6_;
		_tmp4_ = quick_settings_rotation_toggle_new ();
		g_object_ref_sink (_tmp4_);
		rotation_toggle = _tmp4_;
		_tmp5_ = _data1_->toggle_box;
		_tmp6_ = rotation_toggle;
		gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp6_);
		gtk_widget_show_all ((GtkWidget*) self);
		_g_object_unref0 (rotation_toggle);
	}
	_g_object_unref0 (sensor_proxy);
}

static void
__quick_settings_popover_widget___lambda53__gasync_ready_callback (GObject* source_object,
                                                                   GAsyncResult* res,
                                                                   gpointer self)
{
	_quick_settings_popover_widget___lambda53_ (self, source_object, res);
	block1_data_unref (self);
}

static void
_quick_settings_popover_widget___lambda55_ (QuickSettingsPopoverWidget* self)
{
	GtkWidget* _tmp0_;
	GtkPopover* _tmp1_;
	_tmp0_ = gtk_widget_get_ancestor ((GtkWidget*) self, gtk_popover_get_type ());
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_popover_get_type (), GtkPopover));
	_g_object_unref0 (self->priv->popover);
	self->priv->popover = _tmp1_;
}

static void
__quick_settings_popover_widget___lambda55__gtk_widget_realize (GtkWidget* _sender,
                                                                gpointer self)
{
	_quick_settings_popover_widget___lambda55_ ((QuickSettingsPopoverWidget*) self);
}

static void
_quick_settings_popover_widget___lambda56_ (Block1Data* _data1_)
{
	QuickSettingsPopoverWidget* self;
	gboolean _tmp0_ = FALSE;
	GSettings* _tmp1_;
	self = _data1_->self;
	_tmp1_ = _data1_->glib_settings;
	if (g_settings_get_boolean (_tmp1_, "show-a11y")) {
		QuickSettingsSettingsToggle* _tmp2_;
		GtkContainer* _tmp3_;
		GtkContainer* _tmp4_;
		_tmp2_ = _data1_->screen_reader;
		_tmp3_ = gtk_widget_get_parent ((GtkWidget*) _tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_ == NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkFlowBox* _tmp5_;
		QuickSettingsSettingsToggle* _tmp6_;
		GtkFlowBox* _tmp7_;
		QuickSettingsSettingsToggle* _tmp8_;
		GtkBox* _tmp9_;
		QuickSettingsTextScale* _tmp10_;
		_tmp5_ = _data1_->toggle_box;
		_tmp6_ = _data1_->screen_reader;
		gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp6_);
		_tmp7_ = _data1_->toggle_box;
		_tmp8_ = _data1_->onscreen_keyboard;
		gtk_container_add ((GtkContainer*) _tmp7_, (GtkWidget*) _tmp8_);
		_tmp9_ = _data1_->scale_box;
		_tmp10_ = _data1_->text_scale;
		gtk_container_add ((GtkContainer*) _tmp9_, (GtkWidget*) _tmp10_);
	} else {
		GtkFlowBox* _tmp11_;
		QuickSettingsSettingsToggle* _tmp12_;
		GtkFlowBox* _tmp13_;
		QuickSettingsSettingsToggle* _tmp14_;
		GtkBox* _tmp15_;
		QuickSettingsTextScale* _tmp16_;
		_tmp11_ = _data1_->toggle_box;
		_tmp12_ = _data1_->screen_reader;
		gtk_container_remove ((GtkContainer*) _tmp11_, (GtkWidget*) _tmp12_);
		_tmp13_ = _data1_->toggle_box;
		_tmp14_ = _data1_->onscreen_keyboard;
		gtk_container_remove ((GtkContainer*) _tmp13_, (GtkWidget*) _tmp14_);
		_tmp15_ = _data1_->scale_box;
		_tmp16_ = _data1_->text_scale;
		gtk_container_remove ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp16_);
	}
}

static void
__quick_settings_popover_widget___lambda56__g_settings_changed (GSettings* _sender,
                                                                const gchar* key,
                                                                gpointer self)
{
	_quick_settings_popover_widget___lambda56_ (self);
}

static void
_quick_settings_popover_widget___lambda57_ (QuickSettingsPopoverWidget* self)
{
	GtkStack* _tmp0_;
	QuickSettingsUserList* _tmp1_;
	_tmp0_ = self->priv->stack;
	_tmp1_ = self->priv->accounts_view;
	gtk_stack_set_visible_child (_tmp0_, (GtkWidget*) _tmp1_);
}

static void
__quick_settings_popover_widget___lambda57__gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self)
{
	_quick_settings_popover_widget___lambda57_ ((QuickSettingsPopoverWidget*) self);
}

static GObject *
quick_settings_popover_widget_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	QuickSettingsPopoverWidget * self;
	Block1Data* _data1_;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
	gchar* _tmp2_;
	QuickSettingsSettingsToggle* _tmp3_ = NULL;
	QuickSettingsSettingsToggle* _tmp4_;
	GThemedIcon* _tmp5_;
	GThemedIcon* _tmp6_;
	gchar* _tmp7_;
	QuickSettingsSettingsToggle* _tmp8_ = NULL;
	QuickSettingsSettingsToggle* _tmp9_;
	QuickSettingsPreventSleepToggle* prevent_sleep_toggle = NULL;
	QuickSettingsPreventSleepToggle* _tmp10_;
	GtkFlowBox* _tmp11_ = NULL;
	GtkFlowBox* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkFlowBox* _tmp14_;
	QuickSettingsPreventSleepToggle* _tmp15_;
	QuickSettingsTextScale* _tmp16_;
	GtkBox* _tmp17_;
	QuickSettingsCurrentUser* current_user = NULL;
	QuickSettingsCurrentUser* _tmp18_;
	QuickSettingsCurrentUser* _tmp19_;
	GtkWidget* _tmp20_;
	GtkButton* _tmp21_ = NULL;
	GtkButton* _tmp22_;
	GtkStyleContext* _tmp23_;
	GtkButton* _tmp24_;
	GtkStyleContext* _tmp25_;
	GtkButton* _tmp26_;
	GtkStyleContext* _tmp27_;
	QuickSettingsSessionBox* session_box = NULL;
	WingpanelIndicatorManagerServerType _tmp28_;
	QuickSettingsSessionBox* _tmp29_ = NULL;
	GtkBox* bottom_box = NULL;
	GtkBox* _tmp30_;
	GtkBox* _tmp31_;
	GtkButton* _tmp32_;
	GtkBox* _tmp33_;
	QuickSettingsSessionBox* _tmp34_;
	GtkBox* _tmp35_;
	GtkStyleContext* _tmp36_;
	GtkBox* _tmp37_;
	GtkBox* _tmp38_;
	GtkFlowBox* _tmp39_;
	GtkBox* _tmp40_;
	GtkBox* _tmp41_;
	GtkBox* _tmp42_;
	GtkSeparator* _tmp43_;
	GtkSeparator* _tmp44_;
	GtkBox* _tmp45_;
	GtkBox* _tmp46_;
	QuickSettingsUserList* _tmp47_;
	GtkStack* _tmp48_ = NULL;
	GtkStack* _tmp49_;
	GtkBox* _tmp50_;
	GtkStack* _tmp51_;
	QuickSettingsUserList* _tmp52_;
	GtkStack* _tmp53_;
	WingpanelIndicatorManagerServerType _tmp54_;
	WingpanelIndicatorManagerServerType _tmp57_;
	GSettings* applications_settings = NULL;
	GSettings* _tmp61_;
	GSettings* _tmp62_;
	QuickSettingsSettingsToggle* _tmp63_;
	GSettings* _tmp64_;
	QuickSettingsSettingsToggle* _tmp65_;
	GSettings* _tmp66_;
	gboolean _tmp67_ = FALSE;
	WingpanelIndicatorManagerServerType _tmp68_;
	GSettings* _tmp76_;
	GtkButton* _tmp77_;
	parent_class = G_OBJECT_CLASS (quick_settings_popover_widget_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, QUICK_SETTINGS_TYPE_POPOVER_WIDGET, QuickSettingsPopoverWidget);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("orca-symbolic");
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup ("settings://sound");
	_tmp3_ = quick_settings_settings_toggle_new ((GIcon*) _tmp1_, _ ("Screen Reader"));
	quick_settings_settings_toggle_set_settings_uri (_tmp3_, _tmp2_);
	_g_free0 (_tmp2_);
	g_object_ref_sink (_tmp3_);
	_tmp4_ = _tmp3_;
	_g_object_unref0 (_tmp1_);
	_data1_->screen_reader = _tmp4_;
	_tmp5_ = (GThemedIcon*) g_themed_icon_new ("input-keyboard-symbolic");
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strdup ("settings://input/keyboard/behavior");
	_tmp8_ = quick_settings_settings_toggle_new ((GIcon*) _tmp6_, _ ("Onscreen Keyboard"));
	quick_settings_settings_toggle_set_settings_uri (_tmp8_, _tmp7_);
	_g_free0 (_tmp7_);
	g_object_ref_sink (_tmp8_);
	_tmp9_ = _tmp8_;
	_g_object_unref0 (_tmp6_);
	_data1_->onscreen_keyboard = _tmp9_;
	_tmp10_ = quick_settings_prevent_sleep_toggle_new ();
	g_object_ref_sink (_tmp10_);
	prevent_sleep_toggle = _tmp10_;
	_tmp11_ = (GtkFlowBox*) gtk_flow_box_new ();
	gtk_flow_box_set_column_spacing (_tmp11_, (guint) 6);
	gtk_flow_box_set_homogeneous (_tmp11_, TRUE);
	gtk_flow_box_set_max_children_per_line (_tmp11_, (guint) 3);
	gtk_flow_box_set_row_spacing (_tmp11_, (guint) 12);
	gtk_flow_box_set_selection_mode (_tmp11_, GTK_SELECTION_NONE);
	g_object_ref_sink (_tmp11_);
	_data1_->toggle_box = _tmp11_;
	_tmp12_ = _data1_->toggle_box;
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) _tmp12_);
	gtk_style_context_add_class (_tmp13_, "togglebox");
	_tmp14_ = _data1_->toggle_box;
	_tmp15_ = prevent_sleep_toggle;
	gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp15_);
	_tmp16_ = quick_settings_text_scale_new ();
	g_object_ref_sink (_tmp16_);
	_data1_->text_scale = _tmp16_;
	_tmp17_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp17_);
	_data1_->scale_box = _tmp17_;
	_tmp18_ = quick_settings_current_user_new_avatar_only ();
	g_object_ref_sink (_tmp18_);
	current_user = _tmp18_;
	_tmp19_ = current_user;
	_tmp20_ = _g_object_ref0 ((GtkWidget*) _tmp19_);
	_tmp21_ = (GtkButton*) gtk_button_new ();
	g_object_set ((GtkContainer*) _tmp21_, "child", _tmp20_, NULL);
	_g_object_unref0 (_tmp20_);
	g_object_ref_sink (_tmp21_);
	_g_object_unref0 (self->priv->current_user_button);
	self->priv->current_user_button = _tmp21_;
	_tmp22_ = self->priv->current_user_button;
	_tmp23_ = gtk_widget_get_style_context ((GtkWidget*) _tmp22_);
	gtk_style_context_add_class (_tmp23_, "circular");
	_tmp24_ = self->priv->current_user_button;
	_tmp25_ = gtk_widget_get_style_context ((GtkWidget*) _tmp24_);
	gtk_style_context_add_class (_tmp25_, "flat");
	_tmp26_ = self->priv->current_user_button;
	_tmp27_ = gtk_widget_get_style_context ((GtkWidget*) _tmp26_);
	gtk_style_context_add_class (_tmp27_, "no-padding");
	_tmp28_ = self->priv->_server_type;
	_tmp29_ = quick_settings_session_box_new (_tmp28_);
	gtk_widget_set_halign ((GtkWidget*) _tmp29_, GTK_ALIGN_END);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp29_, TRUE);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp29_, 6);
	g_object_ref_sink (_tmp29_);
	session_box = _tmp29_;
	_tmp30_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
	g_object_ref_sink (_tmp30_);
	bottom_box = _tmp30_;
	_tmp31_ = bottom_box;
	_tmp32_ = self->priv->current_user_button;
	gtk_container_add ((GtkContainer*) _tmp31_, (GtkWidget*) _tmp32_);
	_tmp33_ = bottom_box;
	_tmp34_ = session_box;
	gtk_container_add ((GtkContainer*) _tmp33_, (GtkWidget*) _tmp34_);
	_tmp35_ = bottom_box;
	_tmp36_ = gtk_widget_get_style_context ((GtkWidget*) _tmp35_);
	gtk_style_context_add_class (_tmp36_, "togglebox");
	_tmp37_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp37_);
	_g_object_unref0 (self->priv->main_box);
	self->priv->main_box = _tmp37_;
	_tmp38_ = self->priv->main_box;
	_tmp39_ = _data1_->toggle_box;
	gtk_container_add ((GtkContainer*) _tmp38_, (GtkWidget*) _tmp39_);
	_tmp40_ = self->priv->main_box;
	_tmp41_ = _data1_->scale_box;
	gtk_container_add ((GtkContainer*) _tmp40_, (GtkWidget*) _tmp41_);
	_tmp42_ = self->priv->main_box;
	_tmp43_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp43_);
	_tmp44_ = _tmp43_;
	gtk_container_add ((GtkContainer*) _tmp42_, (GtkWidget*) _tmp44_);
	_g_object_unref0 (_tmp44_);
	_tmp45_ = self->priv->main_box;
	_tmp46_ = bottom_box;
	gtk_container_add ((GtkContainer*) _tmp45_, (GtkWidget*) _tmp46_);
	_tmp47_ = quick_settings_user_list_new ();
	g_object_ref_sink (_tmp47_);
	_g_object_unref0 (self->priv->accounts_view);
	self->priv->accounts_view = _tmp47_;
	_tmp48_ = (GtkStack*) gtk_stack_new ();
	gtk_stack_set_vhomogeneous (_tmp48_, FALSE);
	gtk_stack_set_hhomogeneous (_tmp48_, TRUE);
	gtk_stack_set_transition_type (_tmp48_, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT);
	g_object_ref_sink (_tmp48_);
	_g_object_unref0 (self->priv->stack);
	self->priv->stack = _tmp48_;
	_tmp49_ = self->priv->stack;
	_tmp50_ = self->priv->main_box;
	gtk_container_add ((GtkContainer*) _tmp49_, (GtkWidget*) _tmp50_);
	_tmp51_ = self->priv->stack;
	_tmp52_ = self->priv->accounts_view;
	gtk_container_add ((GtkContainer*) _tmp51_, (GtkWidget*) _tmp52_);
	_tmp53_ = self->priv->stack;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp53_);
	_tmp54_ = self->priv->_server_type;
	if (_tmp54_ == WINGPANEL_INDICATOR_MANAGER_SERVER_TYPE_GREETER) {
		GtkBox* _tmp55_;
		GtkButton* _tmp56_;
		_tmp55_ = bottom_box;
		_tmp56_ = self->priv->current_user_button;
		gtk_container_remove ((GtkContainer*) _tmp55_, (GtkWidget*) _tmp56_);
	}
	_tmp57_ = self->priv->_server_type;
	if (_tmp57_ != WINGPANEL_INDICATOR_MANAGER_SERVER_TYPE_GREETER) {
		QuickSettingsDarkModeToggle* darkmode_button = NULL;
		QuickSettingsDarkModeToggle* _tmp58_;
		GtkFlowBox* _tmp59_;
		QuickSettingsDarkModeToggle* _tmp60_;
		_tmp58_ = quick_settings_dark_mode_toggle_new ();
		g_object_ref_sink (_tmp58_);
		darkmode_button = _tmp58_;
		_tmp59_ = _data1_->toggle_box;
		_tmp60_ = darkmode_button;
		gtk_container_add ((GtkContainer*) _tmp59_, (GtkWidget*) _tmp60_);
		gtk_widget_show_all ((GtkWidget*) self);
		_g_object_unref0 (darkmode_button);
	}
	quick_settings_popover_widget_setup_sensor_proxy (self, __quick_settings_popover_widget___lambda53__gasync_ready_callback, block1_data_ref (_data1_));
	g_signal_connect_object ((GtkWidget*) self, "realize", (GCallback) __quick_settings_popover_widget___lambda55__gtk_widget_realize, self, 0);
	_tmp61_ = g_settings_new ("org.gnome.desktop.a11y.applications");
	applications_settings = _tmp61_;
	_tmp62_ = applications_settings;
	_tmp63_ = _data1_->onscreen_keyboard;
	g_settings_bind (_tmp62_, "screen-keyboard-enabled", (GObject*) _tmp63_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp64_ = applications_settings;
	_tmp65_ = _data1_->screen_reader;
	g_settings_bind (_tmp64_, "screen-reader-enabled", (GObject*) _tmp65_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp66_ = g_settings_new ("io.elementary.desktop.quick-settings");
	_data1_->glib_settings = _tmp66_;
	_tmp68_ = self->priv->_server_type;
	if (_tmp68_ == WINGPANEL_INDICATOR_MANAGER_SERVER_TYPE_GREETER) {
		_tmp67_ = TRUE;
	} else {
		GSettings* _tmp69_;
		_tmp69_ = _data1_->glib_settings;
		_tmp67_ = g_settings_get_boolean (_tmp69_, "show-a11y");
	}
	if (_tmp67_) {
		GtkFlowBox* _tmp70_;
		QuickSettingsSettingsToggle* _tmp71_;
		GtkFlowBox* _tmp72_;
		QuickSettingsSettingsToggle* _tmp73_;
		GtkBox* _tmp74_;
		QuickSettingsTextScale* _tmp75_;
		_tmp70_ = _data1_->toggle_box;
		_tmp71_ = _data1_->screen_reader;
		gtk_container_add ((GtkContainer*) _tmp70_, (GtkWidget*) _tmp71_);
		_tmp72_ = _data1_->toggle_box;
		_tmp73_ = _data1_->onscreen_keyboard;
		gtk_container_add ((GtkContainer*) _tmp72_, (GtkWidget*) _tmp73_);
		_tmp74_ = _data1_->scale_box;
		_tmp75_ = _data1_->text_scale;
		gtk_container_add ((GtkContainer*) _tmp74_, (GtkWidget*) _tmp75_);
	}
	_tmp76_ = _data1_->glib_settings;
	g_signal_connect_data (_tmp76_, "changed::show-a11y", (GCallback) __quick_settings_popover_widget___lambda56__g_settings_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp77_ = self->priv->current_user_button;
	g_signal_connect_object (_tmp77_, "clicked", (GCallback) __quick_settings_popover_widget___lambda57__gtk_button_clicked, self, 0);
	_g_object_unref0 (applications_settings);
	_g_object_unref0 (bottom_box);
	_g_object_unref0 (session_box);
	_g_object_unref0 (current_user);
	_g_object_unref0 (prevent_sleep_toggle);
	block1_data_unref (_data1_);
	_data1_ = NULL;
	return obj;
}

static void
quick_settings_popover_widget_base_init (QuickSettingsPopoverWidgetClass * klass)
{
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "quicksettings");
}

static void
quick_settings_popover_widget_class_init (QuickSettingsPopoverWidgetClass * klass,
                                          gpointer klass_data)
{
	quick_settings_popover_widget_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &QuickSettingsPopoverWidget_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_quick_settings_popover_widget_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_quick_settings_popover_widget_set_property;
	G_OBJECT_CLASS (klass)->constructor = quick_settings_popover_widget_constructor;
	G_OBJECT_CLASS (klass)->finalize = quick_settings_popover_widget_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), QUICK_SETTINGS_POPOVER_WIDGET_SERVER_TYPE_PROPERTY, quick_settings_popover_widget_properties[QUICK_SETTINGS_POPOVER_WIDGET_SERVER_TYPE_PROPERTY] = g_param_spec_enum ("server-type", "server-type", "server-type", WINGPANEL_INDICATOR_MANAGER_TYPE_SERVER_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
quick_settings_popover_widget_instance_init (QuickSettingsPopoverWidget * self,
                                             gpointer klass)
{
	self->priv = quick_settings_popover_widget_get_instance_private (self);
}

static void
quick_settings_popover_widget_finalize (GObject * obj)
{
	QuickSettingsPopoverWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, QUICK_SETTINGS_TYPE_POPOVER_WIDGET, QuickSettingsPopoverWidget);
	_g_object_unref0 (self->priv->popover);
	_g_object_unref0 (self->priv->stack);
	_g_object_unref0 (self->priv->main_box);
	_g_object_unref0 (self->priv->accounts_view);
	_g_object_unref0 (self->priv->current_user_button);
	G_OBJECT_CLASS (quick_settings_popover_widget_parent_class)->finalize (obj);
}

static GType
quick_settings_popover_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (QuickSettingsPopoverWidgetClass), (GBaseInitFunc) quick_settings_popover_widget_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) quick_settings_popover_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (QuickSettingsPopoverWidget), 0, (GInstanceInitFunc) quick_settings_popover_widget_instance_init, NULL };
	GType quick_settings_popover_widget_type_id;
	quick_settings_popover_widget_type_id = g_type_register_static (gtk_box_get_type (), "QuickSettingsPopoverWidget", &g_define_type_info, 0);
	QuickSettingsPopoverWidget_private_offset = g_type_add_instance_private (quick_settings_popover_widget_type_id, sizeof (QuickSettingsPopoverWidgetPrivate));
	return quick_settings_popover_widget_type_id;
}

GType
quick_settings_popover_widget_get_type (void)
{
	static volatile gsize quick_settings_popover_widget_type_id__once = 0;
	if (g_once_init_enter (&quick_settings_popover_widget_type_id__once)) {
		GType quick_settings_popover_widget_type_id;
		quick_settings_popover_widget_type_id = quick_settings_popover_widget_get_type_once ();
		g_once_init_leave (&quick_settings_popover_widget_type_id__once, quick_settings_popover_widget_type_id);
	}
	return quick_settings_popover_widget_type_id__once;
}

static void
_vala_quick_settings_popover_widget_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec)
{
	QuickSettingsPopoverWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, QUICK_SETTINGS_TYPE_POPOVER_WIDGET, QuickSettingsPopoverWidget);
	switch (property_id) {
		case QUICK_SETTINGS_POPOVER_WIDGET_SERVER_TYPE_PROPERTY:
		g_value_set_enum (value, quick_settings_popover_widget_get_server_type (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_quick_settings_popover_widget_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec)
{
	QuickSettingsPopoverWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, QUICK_SETTINGS_TYPE_POPOVER_WIDGET, QuickSettingsPopoverWidget);
	switch (property_id) {
		case QUICK_SETTINGS_POPOVER_WIDGET_SERVER_TYPE_PROPERTY:
		quick_settings_popover_widget_set_server_type (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

