/* UserManager.c generated by valac 0.56.18, the Vala compiler
 * generated from UserManager.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2025 elementary, Inc. (https://elementary.io)
 */

#include "quick-settings.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <act/act.h>
#include <sys/types.h>
#include <glib/gi18n-lib.h>
#include <granite.h>

#define QUICK_SETTINGS_USER_MANAGER_LOGIN_IFACE "org.freedesktop.login1"
#define QUICK_SETTINGS_USER_MANAGER_LOGIN_PATH "/org/freedesktop/login1"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	QUICK_SETTINGS_USER_MANAGER_0_PROPERTY,
	QUICK_SETTINGS_USER_MANAGER_NUM_PROPERTIES
};
static GParamSpec* quick_settings_user_manager_properties[QUICK_SETTINGS_USER_MANAGER_NUM_PROPERTIES];

#define QUICK_SETTINGS_TYPE_SYSTEM_INTERFACE (quick_settings_system_interface_get_type ())
#define QUICK_SETTINGS_SYSTEM_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), QUICK_SETTINGS_TYPE_SYSTEM_INTERFACE, QuickSettingsSystemInterface))
#define QUICK_SETTINGS_IS_SYSTEM_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), QUICK_SETTINGS_TYPE_SYSTEM_INTERFACE))
#define QUICK_SETTINGS_SYSTEM_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), QUICK_SETTINGS_TYPE_SYSTEM_INTERFACE, QuickSettingsSystemInterfaceIface))

typedef struct _QuickSettingsSystemInterface QuickSettingsSystemInterface;
typedef struct _QuickSettingsSystemInterfaceIface QuickSettingsSystemInterfaceIface;

#define QUICK_SETTINGS_TYPE_SYSTEM_INTERFACE_PROXY (quick_settings_system_interface_proxy_get_type ())

#define TYPE_USER_INFO (user_info_get_type ())
typedef struct _UserInfo UserInfo;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _QuickSettingsUserManagerInitLoginProxyData QuickSettingsUserManagerInitLoginProxyData;

#define QUICK_SETTINGS_TYPE_USER_INTERFACE (quick_settings_user_interface_get_type ())
#define QUICK_SETTINGS_USER_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), QUICK_SETTINGS_TYPE_USER_INTERFACE, QuickSettingsUserInterface))
#define QUICK_SETTINGS_IS_USER_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), QUICK_SETTINGS_TYPE_USER_INTERFACE))
#define QUICK_SETTINGS_USER_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), QUICK_SETTINGS_TYPE_USER_INTERFACE, QuickSettingsUserInterfaceIface))

typedef struct _QuickSettingsUserInterface QuickSettingsUserInterface;
typedef struct _QuickSettingsUserInterfaceIface QuickSettingsUserInterfaceIface;

#define QUICK_SETTINGS_TYPE_USER_INTERFACE_PROXY (quick_settings_user_interface_proxy_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _QuickSettingsUserManagerGetUserStateData QuickSettingsUserManagerGetUserStateData;
typedef struct _QuickSettingsUserManagerGetGuestStateData QuickSettingsUserManagerGetGuestStateData;
typedef struct _QuickSettingsUserManagerSetupSessionInterfaceData QuickSettingsUserManagerSetupSessionInterfaceData;
typedef struct _QuickSettingsUserManagerGetLoggedinTooltipMarkupData QuickSettingsUserManagerGetLoggedinTooltipMarkupData;

struct _UserInfo {
	guint32 uid;
	gchar* user_name;
	char* user_object;
};

struct _QuickSettingsSystemInterfaceIface {
	GTypeInterface parent_iface;
	void (*suspend) (QuickSettingsSystemInterface* self, gboolean interactive, GError** error);
	void (*reboot) (QuickSettingsSystemInterface* self, gboolean interactive, GError** error);
	void (*power_off) (QuickSettingsSystemInterface* self, gboolean interactive, GError** error);
	void (*reboot_with_flags) (QuickSettingsSystemInterface* self, guint64 flags, GError** error);
	void (*power_off_with_flags) (QuickSettingsSystemInterface* self, guint64 flags, GError** error);
	UserInfo* (*list_users) (QuickSettingsSystemInterface* self, gint* result_length1, GError** error);
	gchar* (*can_suspend) (QuickSettingsSystemInterface* self, GError** error);
};

struct _QuickSettingsUserManagerInitLoginProxyData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	QuickSettingsSystemInterface* _tmp0_;
	QuickSettingsSystemInterface* _tmp1_;
	QuickSettingsSystemInterface* _tmp2_;
	GError* e;
	GError* _tmp3_;
	const gchar* _tmp4_;
	GError* _inner_error0_;
};

struct _QuickSettingsUserInterfaceIface {
	GTypeInterface parent_iface;
	gchar* (*get_state) (QuickSettingsUserInterface* self);
};

struct _QuickSettingsUserManagerGetUserStateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	uid_t uuid;
	UserState result;
	QuickSettingsSystemInterface* _tmp0_;
	UserInfo* users;
	QuickSettingsSystemInterface* _tmp1_;
	gint _tmp2_;
	UserInfo* _tmp3_;
	gint users_length1;
	gint _users_size_;
	UserInfo* _tmp4_;
	gint _tmp4__length1;
	UserInfo* _tmp5_;
	gint _tmp5__length1;
	UserInfo* user_collection;
	gint user_collection_length1;
	gint _user_collection_size_;
	gint user_it;
	UserInfo _tmp6_;
	UserInfo _tmp7_;
	UserInfo user;
	UserInfo _tmp8_;
	UserInfo _tmp9_;
	const char* _tmp10_;
	QuickSettingsUserInterface* user_interface;
	UserInfo _tmp11_;
	const char* _tmp12_;
	QuickSettingsUserInterface* _tmp13_;
	QuickSettingsUserInterface* _tmp14_;
	QuickSettingsUserInterface* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	UserState _tmp19_;
	GError* e;
	GError* _tmp20_;
	const gchar* _tmp21_;
	GError* _inner_error0_;
};

struct _QuickSettingsUserManagerGetGuestStateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	UserState result;
	QuickSettingsSystemInterface* _tmp0_;
	UserInfo* users;
	QuickSettingsSystemInterface* _tmp1_;
	gint _tmp2_;
	UserInfo* _tmp3_;
	gint users_length1;
	gint _users_size_;
	UserInfo* _tmp4_;
	gint _tmp4__length1;
	UserInfo* user_collection;
	gint user_collection_length1;
	gint _user_collection_size_;
	gint user_it;
	UserInfo _tmp5_;
	UserInfo _tmp6_;
	UserInfo user;
	UserState state;
	UserInfo _tmp7_;
	gboolean _tmp8_;
	UserInfo _tmp9_;
	const gchar* _tmp10_;
	GError* e;
	GError* _tmp11_;
	const gchar* _tmp12_;
	GError* _inner_error0_;
};

struct _QuickSettingsUserManagerSetupSessionInterfaceData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	QuickSettingsSessionInterface* result;
	QuickSettingsSessionInterface* _tmp0_;
	QuickSettingsSessionInterface* _tmp1_;
	QuickSettingsSessionInterface* _tmp2_;
	GError* e;
	GError* _tmp3_;
	const gchar* _tmp4_;
	GError* _inner_error0_;
};

struct _QuickSettingsUserManagerGetLoggedinTooltipMarkupData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	gchar* result;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* tooltip_markup;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	ActUserManager* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	gint active_and_online_users;
	ActUserManager* _tmp9_;
	GSList* _tmp10_;
	GSList* user_collection;
	GSList* user_it;
	ActUser* user;
	ActUser* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
	UserState state;
	ActUser* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gboolean _tmp17_;
	gint _tmp18_;
	gint other_users;
	gchar* description;
	gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
};

static gpointer quick_settings_user_manager_parent_class = NULL;
static gchar* quick_settings_user_manager_active_user_real_name;
static gchar* quick_settings_user_manager_active_user_real_name = NULL;
static QuickSettingsSystemInterface* quick_settings_user_manager_login_proxy;
static QuickSettingsSystemInterface* quick_settings_user_manager_login_proxy = NULL;
static ActUserManager* quick_settings_user_manager_usermanager;
static ActUserManager* quick_settings_user_manager_usermanager = NULL;

VALA_EXTERN GType quick_settings_system_interface_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint quick_settings_system_interface_register_object (void* object,
                                                       GDBusConnection* connection,
                                                       const gchar* path,
                                                       GError** error);
VALA_EXTERN GType user_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN UserInfo* user_info_dup (const UserInfo* self);
VALA_EXTERN void user_info_free (UserInfo* self);
VALA_EXTERN void user_info_copy (const UserInfo* self,
                     UserInfo* dest);
VALA_EXTERN void user_info_destroy (UserInfo* self);
VALA_EXTERN GType quick_settings_system_interface_get_type (void) G_GNUC_CONST ;
static void quick_settings_user_manager_init_login_proxy_data_free (gpointer _data);
static void quick_settings_user_manager_init_login_proxy (GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
static void quick_settings_user_manager_init_login_proxy_finish (GAsyncResult* _res_);
static gboolean quick_settings_user_manager_init_login_proxy_co (QuickSettingsUserManagerInitLoginProxyData* _data_);
static void quick_settings_user_manager_init_login_proxy_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_);
static void quick_settings_user_manager_get_user_state_data_free (gpointer _data);
static gboolean quick_settings_user_manager_get_user_state_co (QuickSettingsUserManagerGetUserStateData* _data_);
static void quick_settings_user_manager_get_user_state_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_);
VALA_EXTERN UserInfo* quick_settings_system_interface_list_users (QuickSettingsSystemInterface* self,
                                                      gint* result_length1,
                                                      GError** error);
static void _vala_UserInfo_array_free (UserInfo * array,
                                gssize array_length);
VALA_EXTERN GType quick_settings_user_interface_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType quick_settings_user_interface_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint quick_settings_user_interface_register_object (void* object,
                                                     GDBusConnection* connection,
                                                     const gchar* path,
                                                     GError** error);
VALA_EXTERN gchar* quick_settings_user_interface_get_state (QuickSettingsUserInterface* self);
static void quick_settings_user_manager_get_guest_state_data_free (gpointer _data);
static gboolean quick_settings_user_manager_get_guest_state_co (QuickSettingsUserManagerGetGuestStateData* _data_);
static void quick_settings_user_manager_get_guest_state_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_);
static void quick_settings_user_manager_setup_session_interface_data_free (gpointer _data);
static gboolean quick_settings_user_manager_setup_session_interface_co (QuickSettingsUserManagerSetupSessionInterfaceData* _data_);
static void quick_settings_user_manager_setup_session_interface_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_);
static void quick_settings_user_manager_get_loggedin_tooltip_markup_data_free (gpointer _data);
static gboolean quick_settings_user_manager_get_loggedin_tooltip_markup_co (QuickSettingsUserManagerGetLoggedinTooltipMarkupData* _data_);
static void quick_settings_user_manager_get_loggedin_tooltip_markup_ready (GObject* source_object,
                                                                    GAsyncResult* _res_,
                                                                    gpointer _user_data_);
static void quick_settings_user_manager_finalize (GObject * obj);
static GType quick_settings_user_manager_get_type_once (void);

UserState
user_state_to_enum (const gchar* state)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	UserState result;
	g_return_val_if_fail (state != NULL, 0);
	_tmp0_ = state;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("active")))) {
		switch (0) {
			default:
			{
				result = USER_STATE_ACTIVE;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("online")))) {
		switch (0) {
			default:
			{
				result = USER_STATE_ONLINE;
				return result;
			}
		}
	}
	result = USER_STATE_OFFLINE;
	return result;
}

static GType
user_state_get_type_once (void)
{
	static const GEnumValue values[] = {{USER_STATE_ACTIVE, "USER_STATE_ACTIVE", "active"}, {USER_STATE_ONLINE, "USER_STATE_ONLINE", "online"}, {USER_STATE_OFFLINE, "USER_STATE_OFFLINE", "offline"}, {0, NULL, NULL}};
	GType user_state_type_id;
	user_state_type_id = g_enum_register_static ("UserState", values);
	return user_state_type_id;
}

GType
user_state_get_type (void)
{
	static volatile gsize user_state_type_id__once = 0;
	if (g_once_init_enter (&user_state_type_id__once)) {
		GType user_state_type_id;
		user_state_type_id = user_state_get_type_once ();
		g_once_init_leave (&user_state_type_id__once, user_state_type_id);
	}
	return user_state_type_id__once;
}

static void
quick_settings_user_manager_init_login_proxy_data_free (gpointer _data)
{
	QuickSettingsUserManagerInitLoginProxyData* _data_;
	_data_ = _data;
	g_slice_free (QuickSettingsUserManagerInitLoginProxyData, _data_);
}

static void
quick_settings_user_manager_init_login_proxy (GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	QuickSettingsUserManagerInitLoginProxyData* _data_;
	_data_ = g_slice_new0 (QuickSettingsUserManagerInitLoginProxyData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, quick_settings_user_manager_init_login_proxy_data_free);
	quick_settings_user_manager_init_login_proxy_co (_data_);
}

static void
quick_settings_user_manager_init_login_proxy_finish (GAsyncResult* _res_)
{
	QuickSettingsUserManagerInitLoginProxyData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
quick_settings_user_manager_init_login_proxy_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_)
{
	QuickSettingsUserManagerInitLoginProxyData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	quick_settings_user_manager_init_login_proxy_co (_data_);
}

static gboolean
quick_settings_user_manager_init_login_proxy_co (QuickSettingsUserManagerInitLoginProxyData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	{
		_data_->_state_ = 1;
		g_async_initable_new_async (QUICK_SETTINGS_TYPE_SYSTEM_INTERFACE_PROXY, 0, NULL, quick_settings_user_manager_init_login_proxy_ready, _data_, "g-flags", G_DBUS_PROXY_FLAGS_NONE, "g-name", QUICK_SETTINGS_USER_MANAGER_LOGIN_IFACE, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", QUICK_SETTINGS_USER_MANAGER_LOGIN_PATH, "g-interface-name", "org.freedesktop.login1.Manager", NULL);
		return FALSE;
		_state_1:
		_data_->_tmp1_ = (QuickSettingsSystemInterface*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
		_data_->_tmp0_ = (QuickSettingsSystemInterface*) _data_->_tmp1_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			if (_data_->_inner_error0_->domain == G_IO_ERROR) {
				goto __catch0_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_data_->_tmp2_ = _data_->_tmp0_;
		_data_->_tmp0_ = NULL;
		_g_object_unref0 (quick_settings_user_manager_login_proxy);
		quick_settings_user_manager_login_proxy = _data_->_tmp2_;
		_g_object_unref0 (_data_->_tmp0_);
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp3_ = _data_->e;
		_data_->_tmp4_ = _data_->_tmp3_->message;
		g_critical ("UserManager.vala:34: Failed to create login1 dbus proxy: %s", _data_->_tmp4_);
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
quick_settings_user_manager_get_user_state_data_free (gpointer _data)
{
	QuickSettingsUserManagerGetUserStateData* _data_;
	_data_ = _data;
	g_slice_free (QuickSettingsUserManagerGetUserStateData, _data_);
}

void
quick_settings_user_manager_get_user_state (uid_t uuid,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	QuickSettingsUserManagerGetUserStateData* _data_;
	_data_ = g_slice_new0 (QuickSettingsUserManagerGetUserStateData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, quick_settings_user_manager_get_user_state_data_free);
	_data_->uuid = uuid;
	quick_settings_user_manager_get_user_state_co (_data_);
}

UserState
quick_settings_user_manager_get_user_state_finish (GAsyncResult* _res_)
{
	UserState result;
	QuickSettingsUserManagerGetUserStateData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	return result;
}

static void
quick_settings_user_manager_get_user_state_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_)
{
	QuickSettingsUserManagerGetUserStateData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	quick_settings_user_manager_get_user_state_co (_data_);
}

static void
_vala_UserInfo_array_free (UserInfo * array,
                           gssize array_length)
{
	if (array != NULL) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			user_info_destroy (&array[i]);
		}
	}
	g_free (array);
}

static gboolean
quick_settings_user_manager_get_user_state_co (QuickSettingsUserManagerGetUserStateData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = quick_settings_user_manager_login_proxy;
	if (_data_->_tmp0_ == NULL) {
		_data_->_state_ = 1;
		quick_settings_user_manager_init_login_proxy (quick_settings_user_manager_get_user_state_ready, _data_);
		return FALSE;
		_state_1:
		quick_settings_user_manager_init_login_proxy_finish (_data_->_res_);
	}
	{
		_data_->_tmp1_ = quick_settings_user_manager_login_proxy;
		_data_->_tmp2_ = 0;
		_data_->_tmp3_ = quick_settings_system_interface_list_users (_data_->_tmp1_, &_data_->_tmp2_, &_data_->_inner_error0_);
		_data_->users = _data_->_tmp3_;
		_data_->users_length1 = _data_->_tmp2_;
		_data_->_users_size_ = _data_->users_length1;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp4_ = _data_->users;
		_data_->_tmp4__length1 = _data_->users_length1;
		if (_data_->_tmp4_ == NULL) {
			_data_->result = USER_STATE_OFFLINE;
			_data_->users = (_vala_UserInfo_array_free (_data_->users, _data_->users_length1), NULL);
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
			if (_data_->_state_ != 0) {
				while (!g_task_get_completed (_data_->_async_result)) {
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
				}
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_data_->_tmp5_ = _data_->users;
		_data_->_tmp5__length1 = _data_->users_length1;
		{
			_data_->user_collection_length1 = 0;
			_data_->_user_collection_size_ = 0;
			_data_->user_collection = _data_->_tmp5_;
			_data_->user_collection_length1 = _data_->_tmp5__length1;
			for (_data_->user_it = 0; _data_->user_it < _data_->user_collection_length1; _data_->user_it = _data_->user_it + 1) {
				_data_->_tmp6_ = _data_->user_collection[_data_->user_it];
				memset (&_data_->_tmp7_, 0, sizeof (UserInfo));
				user_info_copy (&_data_->_tmp6_, &_data_->_tmp7_);
				_data_->user = _data_->_tmp7_;
				{
					_data_->_tmp8_ = _data_->user;
					if (((uid_t) _data_->_tmp8_.uid) == _data_->uuid) {
						_data_->_tmp9_ = _data_->user;
						_data_->_tmp10_ = _data_->_tmp9_.user_object;
						if (_data_->_tmp10_ == NULL) {
							_data_->result = USER_STATE_OFFLINE;
							user_info_destroy (&_data_->user);
							_data_->users = (_vala_UserInfo_array_free (_data_->users, _data_->users_length1), NULL);
							g_task_return_pointer (_data_->_async_result, _data_, NULL);
							if (_data_->_state_ != 0) {
								while (!g_task_get_completed (_data_->_async_result)) {
									g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
								}
							}
							g_object_unref (_data_->_async_result);
							return FALSE;
						}
						_data_->_tmp11_ = _data_->user;
						_data_->_tmp12_ = _data_->_tmp11_.user_object;
						_data_->_state_ = 2;
						g_async_initable_new_async (QUICK_SETTINGS_TYPE_USER_INTERFACE_PROXY, 0, NULL, quick_settings_user_manager_get_user_state_ready, _data_, "g-flags", G_DBUS_PROXY_FLAGS_NONE, "g-name", QUICK_SETTINGS_USER_MANAGER_LOGIN_IFACE, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", (const gchar*) _data_->_tmp12_, "g-interface-name", "org.freedesktop.login1.User", NULL);
						return FALSE;
						_state_2:
						_data_->_tmp13_ = (QuickSettingsUserInterface*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
						_data_->user_interface = (QuickSettingsUserInterface*) _data_->_tmp13_;
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
							user_info_destroy (&_data_->user);
							_data_->users = (_vala_UserInfo_array_free (_data_->users, _data_->users_length1), NULL);
							goto __catch0_g_error;
						}
						_data_->_tmp14_ = _data_->user_interface;
						if (_data_->_tmp14_ == NULL) {
							_data_->result = USER_STATE_OFFLINE;
							_g_object_unref0 (_data_->user_interface);
							user_info_destroy (&_data_->user);
							_data_->users = (_vala_UserInfo_array_free (_data_->users, _data_->users_length1), NULL);
							g_task_return_pointer (_data_->_async_result, _data_, NULL);
							if (_data_->_state_ != 0) {
								while (!g_task_get_completed (_data_->_async_result)) {
									g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
								}
							}
							g_object_unref (_data_->_async_result);
							return FALSE;
						}
						_data_->_tmp15_ = _data_->user_interface;
						_data_->_tmp16_ = quick_settings_user_interface_get_state (_data_->_tmp15_);
						_data_->_tmp17_ = _data_->_tmp16_;
						_data_->_tmp18_ = _data_->_tmp17_;
						_data_->_tmp19_ = user_state_to_enum (_data_->_tmp18_);
						_g_free0 (_data_->_tmp18_);
						_data_->result = _data_->_tmp19_;
						_g_object_unref0 (_data_->user_interface);
						user_info_destroy (&_data_->user);
						_data_->users = (_vala_UserInfo_array_free (_data_->users, _data_->users_length1), NULL);
						g_task_return_pointer (_data_->_async_result, _data_, NULL);
						if (_data_->_state_ != 0) {
							while (!g_task_get_completed (_data_->_async_result)) {
								g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
							}
						}
						g_object_unref (_data_->_async_result);
						return FALSE;
					}
					user_info_destroy (&_data_->user);
				}
			}
		}
		_data_->users = (_vala_UserInfo_array_free (_data_->users, _data_->users_length1), NULL);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp20_ = _data_->e;
		_data_->_tmp21_ = _data_->_tmp20_->message;
		g_critical ("UserManager.vala:63: Failed to get user state: %s", _data_->_tmp21_);
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->result = USER_STATE_OFFLINE;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
quick_settings_user_manager_get_guest_state_data_free (gpointer _data)
{
	QuickSettingsUserManagerGetGuestStateData* _data_;
	_data_ = _data;
	g_slice_free (QuickSettingsUserManagerGetGuestStateData, _data_);
}

void
quick_settings_user_manager_get_guest_state (GAsyncReadyCallback _callback_,
                                             gpointer _user_data_)
{
	QuickSettingsUserManagerGetGuestStateData* _data_;
	_data_ = g_slice_new0 (QuickSettingsUserManagerGetGuestStateData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, quick_settings_user_manager_get_guest_state_data_free);
	quick_settings_user_manager_get_guest_state_co (_data_);
}

UserState
quick_settings_user_manager_get_guest_state_finish (GAsyncResult* _res_)
{
	UserState result;
	QuickSettingsUserManagerGetGuestStateData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	return result;
}

static void
quick_settings_user_manager_get_guest_state_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_)
{
	QuickSettingsUserManagerGetGuestStateData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	quick_settings_user_manager_get_guest_state_co (_data_);
}

static gboolean
quick_settings_user_manager_get_guest_state_co (QuickSettingsUserManagerGetGuestStateData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = quick_settings_user_manager_login_proxy;
	if (_data_->_tmp0_ == NULL) {
		_data_->result = USER_STATE_OFFLINE;
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	{
		_data_->_tmp1_ = quick_settings_user_manager_login_proxy;
		_data_->_tmp2_ = 0;
		_data_->_tmp3_ = quick_settings_system_interface_list_users (_data_->_tmp1_, &_data_->_tmp2_, &_data_->_inner_error0_);
		_data_->users = _data_->_tmp3_;
		_data_->users_length1 = _data_->_tmp2_;
		_data_->_users_size_ = _data_->users_length1;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp4_ = _data_->users;
		_data_->_tmp4__length1 = _data_->users_length1;
		{
			_data_->user_collection_length1 = 0;
			_data_->_user_collection_size_ = 0;
			_data_->user_collection = _data_->_tmp4_;
			_data_->user_collection_length1 = _data_->_tmp4__length1;
			for (_data_->user_it = 0; _data_->user_it < _data_->user_collection_length1; _data_->user_it = _data_->user_it + 1) {
				_data_->_tmp5_ = _data_->user_collection[_data_->user_it];
				memset (&_data_->_tmp6_, 0, sizeof (UserInfo));
				user_info_copy (&_data_->_tmp5_, &_data_->_tmp6_);
				_data_->user = _data_->_tmp6_;
				{
					_data_->_tmp7_ = _data_->user;
					_data_->_state_ = 1;
					quick_settings_user_manager_get_user_state ((uid_t) _data_->_tmp7_.uid, quick_settings_user_manager_get_guest_state_ready, _data_);
					return FALSE;
					_state_1:
					_data_->state = quick_settings_user_manager_get_user_state_finish (_data_->_res_);
					_data_->_tmp9_ = _data_->user;
					_data_->_tmp10_ = _data_->_tmp9_.user_name;
					if (g_str_has_prefix (_data_->_tmp10_, "guest-")) {
						_data_->_tmp8_ = _data_->state == USER_STATE_ACTIVE;
					} else {
						_data_->_tmp8_ = FALSE;
					}
					if (_data_->_tmp8_) {
						_data_->result = USER_STATE_ACTIVE;
						user_info_destroy (&_data_->user);
						_data_->users = (_vala_UserInfo_array_free (_data_->users, _data_->users_length1), NULL);
						g_task_return_pointer (_data_->_async_result, _data_, NULL);
						if (_data_->_state_ != 0) {
							while (!g_task_get_completed (_data_->_async_result)) {
								g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
							}
						}
						g_object_unref (_data_->_async_result);
						return FALSE;
					}
					user_info_destroy (&_data_->user);
				}
			}
		}
		_data_->users = (_vala_UserInfo_array_free (_data_->users, _data_->users_length1), NULL);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp11_ = _data_->e;
		_data_->_tmp12_ = _data_->_tmp11_->message;
		g_critical ("UserManager.vala:84: Failed to get Guest state: %s", _data_->_tmp12_);
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->result = USER_STATE_OFFLINE;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

ActUserManager*
quick_settings_user_manager_get_usermanager (void)
{
	gboolean _tmp0_ = FALSE;
	ActUserManager* _tmp1_;
	ActUserManager* _tmp6_;
	ActUserManager* _tmp7_;
	ActUserManager* _tmp8_;
	ActUserManager* result;
	_tmp1_ = quick_settings_user_manager_usermanager;
	if (_tmp1_ != NULL) {
		ActUserManager* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
		_tmp2_ = quick_settings_user_manager_usermanager;
		g_object_get (_tmp2_, "is-loaded", &_tmp3_, NULL);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		ActUserManager* _tmp5_;
		_tmp5_ = quick_settings_user_manager_usermanager;
		result = _tmp5_;
		return result;
	}
	_tmp6_ = act_user_manager_get_default ();
	_tmp7_ = _g_object_ref0 (_tmp6_);
	_g_object_unref0 (quick_settings_user_manager_usermanager);
	quick_settings_user_manager_usermanager = _tmp7_;
	_tmp8_ = quick_settings_user_manager_usermanager;
	result = _tmp8_;
	return result;
}

ActUser*
quick_settings_user_manager_get_current_user (void)
{
	ActUser* current_user = NULL;
	ActUserManager* _tmp0_;
	GSList* _tmp1_;
	ActUser* result;
	current_user = NULL;
	_tmp0_ = quick_settings_user_manager_get_usermanager ();
	_tmp1_ = act_user_manager_list_users (_tmp0_);
	{
		GSList* user_collection = NULL;
		GSList* user_it = NULL;
		user_collection = _tmp1_;
		for (user_it = user_collection; user_it != NULL; user_it = user_it->next) {
			ActUser* user = NULL;
			user = (ActUser*) user_it->data;
			{
				ActUser* _tmp2_;
				_tmp2_ = user;
				if (quick_settings_user_manager_is_current_user (_tmp2_)) {
					ActUser* _tmp3_;
					ActUser* _tmp4_;
					_tmp3_ = user;
					_tmp4_ = _g_object_ref0 (_tmp3_);
					_g_object_unref0 (current_user);
					current_user = _tmp4_;
					break;
				}
			}
		}
		(user_collection == NULL) ? NULL : (user_collection = (g_slist_free (user_collection), NULL));
	}
	result = current_user;
	return result;
}

gboolean
quick_settings_user_manager_is_current_user (ActUser* user)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean result;
	g_return_val_if_fail (user != NULL, FALSE);
	_tmp0_ = act_user_get_user_name (user);
	_tmp1_ = g_get_user_name ();
	result = g_strcmp0 (_tmp0_, _tmp1_) == 0;
	return result;
}

static void
quick_settings_user_manager_setup_session_interface_data_free (gpointer _data)
{
	QuickSettingsUserManagerSetupSessionInterfaceData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->result);
	g_slice_free (QuickSettingsUserManagerSetupSessionInterfaceData, _data_);
}

void
quick_settings_user_manager_setup_session_interface (GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	QuickSettingsUserManagerSetupSessionInterfaceData* _data_;
	_data_ = g_slice_new0 (QuickSettingsUserManagerSetupSessionInterfaceData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, quick_settings_user_manager_setup_session_interface_data_free);
	quick_settings_user_manager_setup_session_interface_co (_data_);
}

QuickSettingsSessionInterface*
quick_settings_user_manager_setup_session_interface_finish (GAsyncResult* _res_)
{
	QuickSettingsSessionInterface* result;
	QuickSettingsUserManagerSetupSessionInterfaceData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static void
quick_settings_user_manager_setup_session_interface_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_)
{
	QuickSettingsUserManagerSetupSessionInterfaceData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	quick_settings_user_manager_setup_session_interface_co (_data_);
}

static gboolean
quick_settings_user_manager_setup_session_interface_co (QuickSettingsUserManagerSetupSessionInterfaceData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	{
		_data_->_state_ = 1;
		g_async_initable_new_async (QUICK_SETTINGS_TYPE_SESSION_INTERFACE_PROXY, 0, NULL, quick_settings_user_manager_setup_session_interface_ready, _data_, "g-flags", 0, "g-name", "org.gnome.SessionManager", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/gnome/SessionManager", "g-interface-name", "org.gnome.SessionManager", NULL);
		return FALSE;
		_state_1:
		_data_->_tmp1_ = (QuickSettingsSessionInterface*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
		_data_->_tmp0_ = (QuickSettingsSessionInterface*) _data_->_tmp1_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			if (_data_->_inner_error0_->domain == G_IO_ERROR) {
				goto __catch0_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_data_->_tmp2_ = _data_->_tmp0_;
		_data_->_tmp0_ = NULL;
		_data_->result = _data_->_tmp2_;
		_g_object_unref0 (_data_->_tmp0_);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp3_ = _data_->e;
		_data_->_tmp4_ = _data_->_tmp3_->message;
		g_critical ("UserManager.vala:121: Unable to connect to GNOME session interface: %s", _data_->_tmp4_);
		_data_->result = NULL;
		_g_error_free0 (_data_->e);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
	g_clear_error (&_data_->_inner_error0_);
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
quick_settings_user_manager_get_loggedin_tooltip_markup_data_free (gpointer _data)
{
	QuickSettingsUserManagerGetLoggedinTooltipMarkupData* _data_;
	_data_ = _data;
	_g_free0 (_data_->result);
	g_slice_free (QuickSettingsUserManagerGetLoggedinTooltipMarkupData, _data_);
}

void
quick_settings_user_manager_get_loggedin_tooltip_markup (GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_)
{
	QuickSettingsUserManagerGetLoggedinTooltipMarkupData* _data_;
	_data_ = g_slice_new0 (QuickSettingsUserManagerGetLoggedinTooltipMarkupData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, quick_settings_user_manager_get_loggedin_tooltip_markup_data_free);
	quick_settings_user_manager_get_loggedin_tooltip_markup_co (_data_);
}

gchar*
quick_settings_user_manager_get_loggedin_tooltip_markup_finish (GAsyncResult* _res_)
{
	gchar* result;
	QuickSettingsUserManagerGetLoggedinTooltipMarkupData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static void
quick_settings_user_manager_get_loggedin_tooltip_markup_ready (GObject* source_object,
                                                               GAsyncResult* _res_,
                                                               gpointer _user_data_)
{
	QuickSettingsUserManagerGetLoggedinTooltipMarkupData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	quick_settings_user_manager_get_loggedin_tooltip_markup_co (_data_);
}

static gboolean
quick_settings_user_manager_get_loggedin_tooltip_markup_co (QuickSettingsUserManagerGetLoggedinTooltipMarkupData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = quick_settings_user_manager_active_user_real_name;
	if (_data_->_tmp0_ == NULL) {
		_data_->_tmp1_ = g_get_real_name ();
		_data_->_tmp2_ = g_strdup (_data_->_tmp1_);
		_g_free0 (quick_settings_user_manager_active_user_real_name);
		quick_settings_user_manager_active_user_real_name = _data_->_tmp2_;
	}
	_data_->_tmp3_ = quick_settings_user_manager_active_user_real_name;
	if (_data_->_tmp3_ == NULL) {
		_data_->result = NULL;
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp4_ = quick_settings_user_manager_active_user_real_name;
	_data_->_tmp5_ = g_strdup_printf (_ ("Logged in as “%s”"), _data_->_tmp4_);
	_data_->tooltip_markup = _data_->_tmp5_;
	_data_->_tmp6_ = quick_settings_user_manager_get_usermanager ();
	g_object_get (_data_->_tmp6_, "is-loaded", &_data_->_tmp7_, NULL);
	_data_->_tmp8_ = _data_->_tmp7_;
	if (!_data_->_tmp8_) {
		g_critical ("UserManager.vala:138: UserManager not yet loaded");
		_data_->result = _data_->tooltip_markup;
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->active_and_online_users = 0;
	_data_->_tmp9_ = quick_settings_user_manager_get_usermanager ();
	_data_->_tmp10_ = act_user_manager_list_users (_data_->_tmp9_);
	{
		_data_->user_collection = _data_->_tmp10_;
		for (_data_->user_it = _data_->user_collection; _data_->user_it != NULL; _data_->user_it = _data_->user_it->next) {
			_data_->user = (ActUser*) _data_->user_it->data;
			{
				_data_->_tmp11_ = _data_->user;
				g_object_get (_data_->_tmp11_, "system-account", &_data_->_tmp12_, NULL);
				_data_->_tmp13_ = _data_->_tmp12_;
				if (_data_->_tmp13_) {
					continue;
				}
				_data_->_tmp14_ = _data_->user;
				_data_->_tmp15_ = act_user_get_uid (_data_->_tmp14_);
				_data_->_tmp16_ = _data_->_tmp15_;
				_data_->_state_ = 1;
				quick_settings_user_manager_get_user_state ((uid_t) _data_->_tmp16_, quick_settings_user_manager_get_loggedin_tooltip_markup_ready, _data_);
				return FALSE;
				_state_1:
				_data_->state = quick_settings_user_manager_get_user_state_finish (_data_->_res_);
				if (_data_->state == USER_STATE_ACTIVE) {
					_data_->_tmp17_ = TRUE;
				} else {
					_data_->_tmp17_ = _data_->state == USER_STATE_ONLINE;
				}
				if (_data_->_tmp17_) {
					_data_->_tmp18_ = _data_->active_and_online_users;
					_data_->active_and_online_users = _data_->_tmp18_ + 1;
				}
			}
		}
		(_data_->user_collection == NULL) ? NULL : (_data_->user_collection = (g_slist_free (_data_->user_collection), NULL));
	}
	_data_->other_users = _data_->active_and_online_users - 1;
	if (_data_->other_users > 0) {
		_data_->_tmp19_ = g_strdup (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%i other person logged in", "%i other people logged in", (gulong) _data_->other_users));
		_data_->description = _data_->_tmp19_;
		_data_->_tmp20_ = _data_->description;
		_data_->_tmp21_ = g_strdup_printf (_data_->_tmp20_, _data_->other_users);
		_g_free0 (_data_->description);
		_data_->description = _data_->_tmp21_;
		_data_->_tmp22_ = _data_->tooltip_markup;
		_data_->_tmp23_ = _data_->description;
		_data_->_tmp24_ = g_strdup_printf (GRANITE_TOOLTIP_SECONDARY_TEXT_MARKUP, _data_->_tmp23_);
		_data_->_tmp25_ = _data_->_tmp24_;
		_data_->_tmp26_ = g_strconcat ("\n", _data_->_tmp25_, NULL);
		_data_->_tmp27_ = _data_->_tmp26_;
		_data_->_tmp28_ = g_strconcat (_data_->_tmp22_, _data_->_tmp27_, NULL);
		_g_free0 (_data_->tooltip_markup);
		_data_->tooltip_markup = _data_->_tmp28_;
		_g_free0 (_data_->_tmp27_);
		_g_free0 (_data_->_tmp25_);
		_g_free0 (_data_->description);
	}
	_data_->result = _data_->tooltip_markup;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

QuickSettingsUserManager*
quick_settings_user_manager_construct (GType object_type)
{
	QuickSettingsUserManager * self = NULL;
	self = (QuickSettingsUserManager*) g_object_new (object_type, NULL);
	return self;
}

QuickSettingsUserManager*
quick_settings_user_manager_new (void)
{
	return quick_settings_user_manager_construct (QUICK_SETTINGS_TYPE_USER_MANAGER);
}

static void
quick_settings_user_manager_class_init (QuickSettingsUserManagerClass * klass,
                                        gpointer klass_data)
{
	quick_settings_user_manager_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = quick_settings_user_manager_finalize;
}

static void
quick_settings_user_manager_instance_init (QuickSettingsUserManager * self,
                                           gpointer klass)
{
}

static void
quick_settings_user_manager_finalize (GObject * obj)
{
	QuickSettingsUserManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, QUICK_SETTINGS_TYPE_USER_MANAGER, QuickSettingsUserManager);
	G_OBJECT_CLASS (quick_settings_user_manager_parent_class)->finalize (obj);
}

static GType
quick_settings_user_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (QuickSettingsUserManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) quick_settings_user_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (QuickSettingsUserManager), 0, (GInstanceInitFunc) quick_settings_user_manager_instance_init, NULL };
	GType quick_settings_user_manager_type_id;
	quick_settings_user_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "QuickSettingsUserManager", &g_define_type_info, 0);
	return quick_settings_user_manager_type_id;
}

GType
quick_settings_user_manager_get_type (void)
{
	static volatile gsize quick_settings_user_manager_type_id__once = 0;
	if (g_once_init_enter (&quick_settings_user_manager_type_id__once)) {
		GType quick_settings_user_manager_type_id;
		quick_settings_user_manager_type_id = quick_settings_user_manager_get_type_once ();
		g_once_init_leave (&quick_settings_user_manager_type_id__once, quick_settings_user_manager_type_id);
	}
	return quick_settings_user_manager_type_id__once;
}

