/* TextScale.c generated by valac 0.56.18, the Vala compiler
 * generated from TextScale.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2024 elementary, Inc. (https://elementary.io)
 */

#include "quick-settings.h"
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	QUICK_SETTINGS_TEXT_SCALE_0_PROPERTY,
	QUICK_SETTINGS_TEXT_SCALE_NUM_PROPERTIES
};
static GParamSpec* quick_settings_text_scale_properties[QUICK_SETTINGS_TEXT_SCALE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block8Data Block8Data;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _QuickSettingsTextScalePrivate {
	GtkButton* zoom_in_button;
	GtkButton* zoom_out_button;
	GSettings* interface_settings;
};

struct _Block8Data {
	int _ref_count_;
	QuickSettingsTextScale* self;
	GtkAdjustment* zoom_adjustment;
	guint update_timeout_id;
};

static gint QuickSettingsTextScale_private_offset;
static gpointer quick_settings_text_scale_parent_class = NULL;

static void quick_settings_text_scale_update_zoom_buttons (QuickSettingsTextScale* self);
static GObject * quick_settings_text_scale_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void _quick_settings_text_scale_update_zoom_buttons_g_settings_changed (GSettings* _sender,
                                                                        const gchar* key,
                                                                        gpointer self);
static void _quick_settings_text_scale___lambda23_ (Block8Data* _data8_);
static gboolean __lambda24_ (Block8Data* _data8_);
static gboolean ___lambda24__gsource_func (gpointer self);
static void __quick_settings_text_scale___lambda23__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                           gpointer self);
static void _quick_settings_text_scale___lambda25_ (Block8Data* _data8_);
static void __quick_settings_text_scale___lambda25__gtk_button_clicked (GtkButton* _sender,
                                                                 gpointer self);
static void _quick_settings_text_scale___lambda26_ (Block8Data* _data8_);
static void __quick_settings_text_scale___lambda26__gtk_button_clicked (GtkButton* _sender,
                                                                 gpointer self);
static void quick_settings_text_scale_finalize (GObject * obj);
static GType quick_settings_text_scale_get_type_once (void);

static inline gpointer
quick_settings_text_scale_get_instance_private (QuickSettingsTextScale* self)
{
	return G_STRUCT_MEMBER_P (self, QuickSettingsTextScale_private_offset);
}

static void
quick_settings_text_scale_update_zoom_buttons (QuickSettingsTextScale* self)
{
	gdouble scaling_factor = 0.0;
	GSettings* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->interface_settings;
	scaling_factor = g_settings_get_double (_tmp0_, "text-scaling-factor");
	_tmp1_ = self->priv->zoom_in_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, scaling_factor < 1.75);
	_tmp2_ = self->priv->zoom_out_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, scaling_factor > 0.75);
}

QuickSettingsTextScale*
quick_settings_text_scale_construct (GType object_type)
{
	QuickSettingsTextScale * self = NULL;
	self = (QuickSettingsTextScale*) g_object_new (object_type, NULL);
	return self;
}

QuickSettingsTextScale*
quick_settings_text_scale_new (void)
{
	return quick_settings_text_scale_construct (QUICK_SETTINGS_TYPE_TEXT_SCALE);
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
	g_atomic_int_inc (&_data8_->_ref_count_);
	return _data8_;
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
		QuickSettingsTextScale* self;
		self = _data8_->self;
		_g_object_unref0 (_data8_->zoom_adjustment);
		_g_object_unref0 (self);
		g_slice_free (Block8Data, _data8_);
	}
}

static void
_quick_settings_text_scale_update_zoom_buttons_g_settings_changed (GSettings* _sender,
                                                                   const gchar* key,
                                                                   gpointer self)
{
	quick_settings_text_scale_update_zoom_buttons ((QuickSettingsTextScale*) self);
}

static gboolean
__lambda24_ (Block8Data* _data8_)
{
	QuickSettingsTextScale* self;
	GSettings* _tmp0_;
	GtkAdjustment* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gboolean result;
	self = _data8_->self;
	_data8_->update_timeout_id = (guint) 0;
	_tmp0_ = self->priv->interface_settings;
	_tmp1_ = _data8_->zoom_adjustment;
	_tmp2_ = gtk_adjustment_get_value (_tmp1_);
	_tmp3_ = _tmp2_;
	g_settings_set_double (_tmp0_, "text-scaling-factor", _tmp3_);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda24__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda24_ (self);
	return result;
}

static void
_quick_settings_text_scale___lambda23_ (Block8Data* _data8_)
{
	QuickSettingsTextScale* self;
	self = _data8_->self;
	if (_data8_->update_timeout_id != ((guint) 0)) {
		g_source_remove (_data8_->update_timeout_id);
	}
	_data8_->update_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 300, ___lambda24__gsource_func, block8_data_ref (_data8_), block8_data_unref);
}

static void
__quick_settings_text_scale___lambda23__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                      gpointer self)
{
	_quick_settings_text_scale___lambda23_ (self);
}

static void
_quick_settings_text_scale___lambda25_ (Block8Data* _data8_)
{
	QuickSettingsTextScale* self;
	GtkAdjustment* _tmp0_;
	GtkAdjustment* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	self = _data8_->self;
	_tmp0_ = _data8_->zoom_adjustment;
	_tmp1_ = _data8_->zoom_adjustment;
	_tmp2_ = gtk_adjustment_get_value (_tmp1_);
	_tmp3_ = _tmp2_;
	gtk_adjustment_set_value (_tmp1_, _tmp3_ + 0.05);
}

static void
__quick_settings_text_scale___lambda25__gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self)
{
	_quick_settings_text_scale___lambda25_ (self);
}

static void
_quick_settings_text_scale___lambda26_ (Block8Data* _data8_)
{
	QuickSettingsTextScale* self;
	GtkAdjustment* _tmp0_;
	GtkAdjustment* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	self = _data8_->self;
	_tmp0_ = _data8_->zoom_adjustment;
	_tmp1_ = _data8_->zoom_adjustment;
	_tmp2_ = gtk_adjustment_get_value (_tmp1_);
	_tmp3_ = _tmp2_;
	gtk_adjustment_set_value (_tmp1_, _tmp3_ + (-0.05));
}

static void
__quick_settings_text_scale___lambda26__gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self)
{
	_quick_settings_text_scale___lambda26_ (self);
}

static GObject *
quick_settings_text_scale_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	QuickSettingsTextScale * self;
	Block8Data* _data8_;
	gchar* _tmp0_;
	GtkButton* _tmp1_ = NULL;
	GtkButton* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkAdjustment* _tmp4_;
	GtkScale* zoom_scale = NULL;
	GtkAdjustment* _tmp5_;
	GtkScale* _tmp6_ = NULL;
	GtkScale* _tmp7_;
	GtkScale* _tmp8_;
	gchar* _tmp9_;
	GtkButton* _tmp10_ = NULL;
	GtkButton* _tmp11_;
	GtkStyleContext* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkButton* _tmp14_;
	GtkScale* _tmp15_;
	GtkButton* _tmp16_;
	GSettings* _tmp17_;
	GSettings* _tmp18_;
	GtkAdjustment* _tmp19_;
	GSettings* _tmp20_;
	GtkAdjustment* _tmp21_;
	GtkButton* _tmp22_;
	GtkButton* _tmp23_;
	parent_class = G_OBJECT_CLASS (quick_settings_text_scale_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, QUICK_SETTINGS_TYPE_TEXT_SCALE, QuickSettingsTextScale);
	_data8_ = g_slice_new0 (Block8Data);
	_data8_->_ref_count_ = 1;
	_data8_->self = g_object_ref (self);
	_tmp0_ = g_strdup (_ ("Decrease text size"));
	_tmp1_ = (GtkButton*) gtk_button_new_from_icon_name ("format-text-smaller-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp1_, _tmp0_);
	_g_free0 (_tmp0_);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->zoom_out_button);
	self->priv->zoom_out_button = _tmp1_;
	_tmp2_ = self->priv->zoom_out_button;
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
	gtk_style_context_add_class (_tmp3_, "circular");
	_tmp4_ = gtk_adjustment_new ((gdouble) -1, 0.75, 1.75, 0.05, (gdouble) 0, (gdouble) 0);
	g_object_ref_sink (_tmp4_);
	_data8_->zoom_adjustment = _tmp4_;
	_tmp5_ = _data8_->zoom_adjustment;
	_tmp6_ = (GtkScale*) gtk_scale_new (GTK_ORIENTATION_HORIZONTAL, _tmp5_);
	gtk_scale_set_draw_value (_tmp6_, FALSE);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp6_, TRUE);
	g_object_ref_sink (_tmp6_);
	zoom_scale = _tmp6_;
	_tmp7_ = zoom_scale;
	gtk_scale_add_mark (_tmp7_, (gdouble) 1, GTK_POS_BOTTOM, NULL);
	_tmp8_ = zoom_scale;
	gtk_scale_add_mark (_tmp8_, 1.5, GTK_POS_BOTTOM, NULL);
	_tmp9_ = g_strdup (_ ("Increase text size"));
	_tmp10_ = (GtkButton*) gtk_button_new_from_icon_name ("format-text-larger-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp10_, _tmp9_);
	_g_free0 (_tmp9_);
	g_object_ref_sink (_tmp10_);
	_g_object_unref0 (self->priv->zoom_in_button);
	self->priv->zoom_in_button = _tmp10_;
	_tmp11_ = self->priv->zoom_in_button;
	_tmp12_ = gtk_widget_get_style_context ((GtkWidget*) _tmp11_);
	gtk_style_context_add_class (_tmp12_, "circular");
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp13_, "font-size");
	_tmp14_ = self->priv->zoom_out_button;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp14_);
	_tmp15_ = zoom_scale;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp15_);
	_tmp16_ = self->priv->zoom_in_button;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp16_);
	_tmp17_ = g_settings_new ("org.gnome.desktop.interface");
	_g_object_unref0 (self->priv->interface_settings);
	self->priv->interface_settings = _tmp17_;
	_tmp18_ = self->priv->interface_settings;
	_tmp19_ = _data8_->zoom_adjustment;
	g_settings_bind (_tmp18_, "text-scaling-factor", (GObject*) _tmp19_, "value", G_SETTINGS_BIND_GET);
	_tmp20_ = self->priv->interface_settings;
	g_signal_connect_object (_tmp20_, "changed::text-scaling-factor", (GCallback) _quick_settings_text_scale_update_zoom_buttons_g_settings_changed, self, 0);
	quick_settings_text_scale_update_zoom_buttons (self);
	_data8_->update_timeout_id = (guint) 0;
	_tmp21_ = _data8_->zoom_adjustment;
	g_signal_connect_data (_tmp21_, "value-changed", (GCallback) __quick_settings_text_scale___lambda23__gtk_adjustment_value_changed, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
	_tmp22_ = self->priv->zoom_in_button;
	g_signal_connect_data (_tmp22_, "clicked", (GCallback) __quick_settings_text_scale___lambda25__gtk_button_clicked, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
	_tmp23_ = self->priv->zoom_out_button;
	g_signal_connect_data (_tmp23_, "clicked", (GCallback) __quick_settings_text_scale___lambda26__gtk_button_clicked, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
	_g_object_unref0 (zoom_scale);
	block8_data_unref (_data8_);
	_data8_ = NULL;
	return obj;
}

static void
quick_settings_text_scale_base_init (QuickSettingsTextScaleClass * klass)
{
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "scalebox");
}

static void
quick_settings_text_scale_class_init (QuickSettingsTextScaleClass * klass,
                                      gpointer klass_data)
{
	quick_settings_text_scale_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &QuickSettingsTextScale_private_offset);
	G_OBJECT_CLASS (klass)->constructor = quick_settings_text_scale_constructor;
	G_OBJECT_CLASS (klass)->finalize = quick_settings_text_scale_finalize;
}

static void
quick_settings_text_scale_instance_init (QuickSettingsTextScale * self,
                                         gpointer klass)
{
	self->priv = quick_settings_text_scale_get_instance_private (self);
}

static void
quick_settings_text_scale_finalize (GObject * obj)
{
	QuickSettingsTextScale * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, QUICK_SETTINGS_TYPE_TEXT_SCALE, QuickSettingsTextScale);
	_g_object_unref0 (self->priv->zoom_in_button);
	_g_object_unref0 (self->priv->zoom_out_button);
	_g_object_unref0 (self->priv->interface_settings);
	G_OBJECT_CLASS (quick_settings_text_scale_parent_class)->finalize (obj);
}

static GType
quick_settings_text_scale_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (QuickSettingsTextScaleClass), (GBaseInitFunc) quick_settings_text_scale_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) quick_settings_text_scale_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (QuickSettingsTextScale), 0, (GInstanceInitFunc) quick_settings_text_scale_instance_init, NULL };
	GType quick_settings_text_scale_type_id;
	quick_settings_text_scale_type_id = g_type_register_static (gtk_box_get_type (), "QuickSettingsTextScale", &g_define_type_info, 0);
	QuickSettingsTextScale_private_offset = g_type_add_instance_private (quick_settings_text_scale_type_id, sizeof (QuickSettingsTextScalePrivate));
	return quick_settings_text_scale_type_id;
}

GType
quick_settings_text_scale_get_type (void)
{
	static volatile gsize quick_settings_text_scale_type_id__once = 0;
	if (g_once_init_enter (&quick_settings_text_scale_type_id__once)) {
		GType quick_settings_text_scale_type_id;
		quick_settings_text_scale_type_id = quick_settings_text_scale_get_type_once ();
		g_once_init_leave (&quick_settings_text_scale_type_id__once, quick_settings_text_scale_type_id);
	}
	return quick_settings_text_scale_type_id__once;
}

