/* UserList.c generated by valac 0.56.18, the Vala compiler
 * generated from UserList.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2024 elementary, Inc. (https://elementary.io)
 */

#include "quick-settings.h"
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <sys/types.h>
#include <gtk/gtk.h>
#include <act/act.h>
#include <glib/gi18n-lib.h>

#define QUICK_SETTINGS_USER_LIST_GUEST_USER_UID ((uid_t) 999)
#define QUICK_SETTINGS_USER_LIST_DM_DBUS_ID "org.freedesktop.DisplayManager"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define QUICK_SETTINGS_TYPE_SEAT_INTERFACE (quick_settings_seat_interface_get_type ())
#define QUICK_SETTINGS_SEAT_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), QUICK_SETTINGS_TYPE_SEAT_INTERFACE, QuickSettingsSeatInterface))
#define QUICK_SETTINGS_IS_SEAT_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), QUICK_SETTINGS_TYPE_SEAT_INTERFACE))
#define QUICK_SETTINGS_SEAT_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), QUICK_SETTINGS_TYPE_SEAT_INTERFACE, QuickSettingsSeatInterfaceIface))

typedef struct _QuickSettingsSeatInterface QuickSettingsSeatInterface;
typedef struct _QuickSettingsSeatInterfaceIface QuickSettingsSeatInterfaceIface;

#define QUICK_SETTINGS_TYPE_SEAT_INTERFACE_PROXY (quick_settings_seat_interface_proxy_get_type ())
enum  {
	QUICK_SETTINGS_USER_LIST_0_PROPERTY,
	QUICK_SETTINGS_USER_LIST_NUM_PROPERTIES
};
static GParamSpec* quick_settings_user_list_properties[QUICK_SETTINGS_USER_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block9Data Block9Data;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block10Data Block10Data;
enum  {
	QUICK_SETTINGS_USER_LIST_SWITCH_TO_GUEST_SIGNAL,
	QUICK_SETTINGS_USER_LIST_SWITCH_TO_USER_SIGNAL,
	QUICK_SETTINGS_USER_LIST_NUM_SIGNALS
};
static guint quick_settings_user_list_signals[QUICK_SETTINGS_USER_LIST_NUM_SIGNALS] = {0};

struct _QuickSettingsSeatInterfaceIface {
	GTypeInterface parent_iface;
	void (*switch_to_guest) (QuickSettingsSeatInterface* self, const gchar* session_name, GError** error);
	void (*switch_to_user) (QuickSettingsSeatInterface* self, const gchar* username, const gchar* session_name, GError** error);
	gboolean (*get_has_guest_account) (QuickSettingsSeatInterface* self);
};

struct _QuickSettingsUserListPrivate {
	QuickSettingsSeatInterface* dm_proxy;
	GHashTable* user_map;
	GtkListBox* listbox;
	GtkPopover* popover;
	GtkRevealer* user_list_revealer;
};

struct _Block9Data {
	int _ref_count_;
	QuickSettingsUserList* self;
	QuickSettingsCurrentUser* current_user;
	gchar* session_path;
};

struct _Block10Data {
	int _ref_count_;
	Block9Data * _data9_;
	QuickSettingsSessionInterface* session_interface;
};

static gint QuickSettingsUserList_private_offset;
static gpointer quick_settings_user_list_parent_class = NULL;

VALA_EXTERN GType quick_settings_seat_interface_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint quick_settings_seat_interface_register_object (void* object,
                                                     GDBusConnection* connection,
                                                     const gchar* path,
                                                     GError** error);
VALA_EXTERN GType quick_settings_seat_interface_get_type (void) G_GNUC_CONST ;
static void quick_settings_user_list_init_users (QuickSettingsUserList* self);
static void quick_settings_user_list_add_user (QuickSettingsUserList* self,
                                        ActUser* user);
static uid_t* _uid_t_dup (uid_t* self);
static void quick_settings_user_list_add_guest (QuickSettingsUserList* self);
static void quick_settings_user_list_remove_user (QuickSettingsUserList* self,
                                           ActUser* user);
static void quick_settings_user_list_update_user (QuickSettingsUserList* self,
                                           ActUser* user);
static void quick_settings_user_list_show_settings (QuickSettingsUserList* self);
static GObject * quick_settings_user_list_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static guint _quick_settings_user_list___lambda5_ (uid_t* k);
static guint __quick_settings_user_list___lambda5__ghash_func (gconstpointer key);
static gboolean _quick_settings_user_list___lambda6_ (uid_t* k1,
                                               uid_t* k2);
static gboolean _uid_t_equal (const uid_t * s1,
                       const uid_t * s2);
static gboolean __quick_settings_user_list___lambda6__gequal_func (gconstpointer a,
                                                            gconstpointer b);
static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static gint _quick_settings_user_list_sort_func_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                 GtkListBoxRow* row2,
                                                                 gpointer self);
static void _quick_settings_user_list____lambda12_ (QuickSettingsUserList* self);
static void __quick_settings_user_list____lambda12__g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self);
static void _quick_settings_user_list_add_user_act_user_manager_user_added (ActUserManager* _sender,
                                                                     ActUser* user,
                                                                     gpointer self);
static void _quick_settings_user_list_remove_user_act_user_manager_user_removed (ActUserManager* _sender,
                                                                          ActUser* user,
                                                                          gpointer self);
static void _quick_settings_user_list_update_user_act_user_manager_user_changed (ActUserManager* _sender,
                                                                          ActUser* user,
                                                                          gpointer self);
VALA_EXTERN gboolean quick_settings_seat_interface_get_has_guest_account (QuickSettingsSeatInterface* self);
static void _quick_settings_user_list____lambda13_ (QuickSettingsUserList* self);
VALA_EXTERN void quick_settings_seat_interface_switch_to_guest (QuickSettingsSeatInterface* self,
                                                    const gchar* session_name,
                                                    GError** error);
static void __quick_settings_user_list____lambda13__quick_settings_user_list_switch_to_guest (QuickSettingsUserList* _sender,
                                                                                       gpointer self);
static void _quick_settings_user_list____lambda14_ (Block9Data* _data9_,
                                             const gchar* username);
VALA_EXTERN void quick_settings_seat_interface_switch_to_user (QuickSettingsSeatInterface* self,
                                                   const gchar* username,
                                                   const gchar* session_name,
                                                   GError** error);
static void __quick_settings_user_list____lambda14__quick_settings_user_list_switch_to_user (QuickSettingsUserList* _sender,
                                                                                      const gchar* username,
                                                                                      gpointer self);
static void _quick_settings_user_list___lambda15_ (QuickSettingsUserList* self,
                                            GtkListBoxRow* row);
static void __quick_settings_user_list___lambda15__gtk_list_box_row_activated (GtkListBox* _sender,
                                                                        GtkListBoxRow* row,
                                                                        gpointer self);
static void _quick_settings_user_list___lambda16_ (QuickSettingsUserList* self);
static void __quick_settings_user_list___lambda16__gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self);
static void _quick_settings_user_list___lambda17_ (QuickSettingsUserList* self);
static void __quick_settings_user_list___lambda17__gtk_widget_realize (GtkWidget* _sender,
                                                                gpointer self);
static void _quick_settings_user_list___lambda18_ (Block9Data* _data9_,
                                            GObject* obj,
                                            GAsyncResult* res);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void __lambda19_ (Block10Data* _data10_);
static void __lambda20_ (Block10Data* _data10_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda20__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void ___lambda19__quick_settings_current_user_logout (QuickSettingsCurrentUser* _sender,
                                                      gpointer self);
static void __quick_settings_user_list___lambda18__gasync_ready_callback (GObject* source_object,
                                                                   GAsyncResult* res,
                                                                   gpointer self);
static void quick_settings_user_list_finalize (GObject * obj);
static GType quick_settings_user_list_get_type_once (void);

static inline gpointer
quick_settings_user_list_get_instance_private (QuickSettingsUserList* self)
{
	return G_STRUCT_MEMBER_P (self, QuickSettingsUserList_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
quick_settings_user_list_init_users (QuickSettingsUserList* self)
{
	ActUserManager* _tmp0_;
	GSList* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = quick_settings_user_manager_get_usermanager ();
	_tmp1_ = act_user_manager_list_users (_tmp0_);
	{
		GSList* user_collection = NULL;
		GSList* user_it = NULL;
		user_collection = _tmp1_;
		for (user_it = user_collection; user_it != NULL; user_it = user_it->next) {
			ActUser* _tmp2_;
			ActUser* user = NULL;
			_tmp2_ = _g_object_ref0 ((ActUser*) user_it->data);
			user = _tmp2_;
			{
				ActUser* _tmp3_;
				_tmp3_ = user;
				quick_settings_user_list_add_user (self, _tmp3_);
				_g_object_unref0 (user);
			}
		}
		(user_collection == NULL) ? NULL : (user_collection = (g_slist_free (user_collection), NULL));
	}
}

static uid_t*
_uid_t_dup (uid_t* self)
{
	uid_t* dup;
	dup = g_new0 (uid_t, 1);
	memcpy (dup, self, sizeof (uid_t));
	return dup;
}

static gpointer
__uid_t_dup0 (gpointer self)
{
	return self ? _uid_t_dup (self) : NULL;
}

static void
quick_settings_user_list_add_user (QuickSettingsUserList* self,
                                   ActUser* user)
{
	uid_t uid = 0;
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	uid_t* _tmp2_;
	QuickSettingsUserRow* _tmp3_;
	GHashTable* _tmp4_;
	gconstpointer _tmp5_;
	GtkListBox* _tmp6_;
	GHashTable* _tmp7_;
	gconstpointer _tmp8_;
	GtkRevealer* _tmp9_;
	GtkListBox* _tmp10_;
	GtkListBoxRow* _tmp11_;
	g_return_if_fail (self != NULL);
	if (act_user_is_system_account (user)) {
		return;
	}
	uid = act_user_get_uid (user);
	_tmp0_ = self->priv->user_map;
	if (g_hash_table_contains (_tmp0_, &uid)) {
		return;
	}
	if (quick_settings_user_manager_is_current_user (user)) {
		return;
	}
	_tmp1_ = self->priv->user_map;
	_tmp2_ = __uid_t_dup0 (&uid);
	_tmp3_ = quick_settings_user_row_new (user);
	g_object_ref_sink (_tmp3_);
	g_hash_table_insert (_tmp1_, _tmp2_, _tmp3_);
	_tmp4_ = self->priv->user_map;
	_tmp5_ = g_hash_table_lookup (_tmp4_, &uid);
	gtk_widget_show ((GtkWidget*) ((QuickSettingsUserRow*) _tmp5_));
	_tmp6_ = self->priv->listbox;
	_tmp7_ = self->priv->user_map;
	_tmp8_ = g_hash_table_lookup (_tmp7_, &uid);
	gtk_container_add ((GtkContainer*) _tmp6_, (GtkWidget*) ((QuickSettingsUserRow*) _tmp8_));
	_tmp9_ = self->priv->user_list_revealer;
	_tmp10_ = self->priv->listbox;
	_tmp11_ = gtk_list_box_get_row_at_index (_tmp10_, 0);
	gtk_revealer_set_reveal_child (_tmp9_, _tmp11_ != NULL);
}

static void
quick_settings_user_list_add_guest (QuickSettingsUserList* self)
{
	GHashTable* _tmp0_;
	uid_t _tmp1_;
	gconstpointer _tmp2_;
	ActUser* _tmp3_;
	ActUser* _tmp4_;
	gboolean _tmp5_;
	GHashTable* _tmp6_;
	uid_t _tmp7_;
	uid_t* _tmp8_;
	QuickSettingsUserRow* _tmp9_;
	GHashTable* _tmp10_;
	uid_t _tmp11_;
	gconstpointer _tmp12_;
	GtkListBox* _tmp13_;
	GHashTable* _tmp14_;
	uid_t _tmp15_;
	gconstpointer _tmp16_;
	GtkRevealer* _tmp17_;
	GtkListBox* _tmp18_;
	GtkListBoxRow* _tmp19_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->user_map;
	_tmp1_ = QUICK_SETTINGS_USER_LIST_GUEST_USER_UID;
	_tmp2_ = g_hash_table_lookup (_tmp0_, &_tmp1_);
	if (((QuickSettingsUserRow*) _tmp2_) != NULL) {
		return;
	}
	_tmp3_ = quick_settings_user_manager_get_current_user ();
	_tmp4_ = _tmp3_;
	_tmp5_ = _tmp4_ == NULL;
	_g_object_unref0 (_tmp4_);
	if (_tmp5_) {
		return;
	}
	_tmp6_ = self->priv->user_map;
	_tmp7_ = QUICK_SETTINGS_USER_LIST_GUEST_USER_UID;
	_tmp8_ = __uid_t_dup0 (&_tmp7_);
	_tmp9_ = quick_settings_user_row_new_guest ();
	g_object_ref_sink (_tmp9_);
	g_hash_table_insert (_tmp6_, _tmp8_, _tmp9_);
	_tmp10_ = self->priv->user_map;
	_tmp11_ = QUICK_SETTINGS_USER_LIST_GUEST_USER_UID;
	_tmp12_ = g_hash_table_lookup (_tmp10_, &_tmp11_);
	gtk_widget_show ((GtkWidget*) ((QuickSettingsUserRow*) _tmp12_));
	_tmp13_ = self->priv->listbox;
	_tmp14_ = self->priv->user_map;
	_tmp15_ = QUICK_SETTINGS_USER_LIST_GUEST_USER_UID;
	_tmp16_ = g_hash_table_lookup (_tmp14_, &_tmp15_);
	gtk_container_add ((GtkContainer*) _tmp13_, (GtkWidget*) ((QuickSettingsUserRow*) _tmp16_));
	_tmp17_ = self->priv->user_list_revealer;
	_tmp18_ = self->priv->listbox;
	_tmp19_ = gtk_list_box_get_row_at_index (_tmp18_, 0);
	gtk_revealer_set_reveal_child (_tmp17_, _tmp19_ != NULL);
}

static void
quick_settings_user_list_remove_user (QuickSettingsUserList* self,
                                      ActUser* user)
{
	uid_t uid = 0;
	QuickSettingsUserRow* user_row = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	QuickSettingsUserRow* _tmp2_;
	QuickSettingsUserRow* _tmp3_;
	GHashTable* _tmp4_;
	GtkListBox* _tmp5_;
	QuickSettingsUserRow* _tmp6_;
	GtkListBox* _tmp7_;
	GtkRevealer* _tmp8_;
	GtkListBox* _tmp9_;
	GtkListBoxRow* _tmp10_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (user != NULL);
	uid = act_user_get_uid (user);
	_tmp0_ = self->priv->user_map;
	_tmp1_ = g_hash_table_lookup (_tmp0_, &uid);
	_tmp2_ = _g_object_ref0 ((QuickSettingsUserRow*) _tmp1_);
	user_row = _tmp2_;
	_tmp3_ = user_row;
	if (_tmp3_ == NULL) {
		_g_object_unref0 (user_row);
		return;
	}
	_tmp4_ = self->priv->user_map;
	g_hash_table_remove (_tmp4_, &uid);
	_tmp5_ = self->priv->listbox;
	_tmp6_ = user_row;
	gtk_container_remove ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp6_);
	_tmp7_ = self->priv->listbox;
	gtk_list_box_invalidate_sort (_tmp7_);
	_tmp8_ = self->priv->user_list_revealer;
	_tmp9_ = self->priv->listbox;
	_tmp10_ = gtk_list_box_get_row_at_index (_tmp9_, 0);
	gtk_revealer_set_reveal_child (_tmp8_, _tmp10_ != NULL);
	_g_object_unref0 (user_row);
}

static void
quick_settings_user_list_update_user (QuickSettingsUserList* self,
                                      ActUser* user)
{
	QuickSettingsUserRow* userbox = NULL;
	GHashTable* _tmp0_;
	uid_t _tmp1_;
	gconstpointer _tmp2_;
	QuickSettingsUserRow* _tmp3_;
	QuickSettingsUserRow* _tmp4_;
	QuickSettingsUserRow* _tmp5_;
	GtkRevealer* _tmp6_;
	GtkListBox* _tmp7_;
	GtkListBoxRow* _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (user != NULL);
	_tmp0_ = self->priv->user_map;
	_tmp1_ = act_user_get_uid (user);
	_tmp2_ = g_hash_table_lookup (_tmp0_, &_tmp1_);
	_tmp3_ = _g_object_ref0 ((QuickSettingsUserRow*) _tmp2_);
	userbox = _tmp3_;
	_tmp4_ = userbox;
	if (_tmp4_ == NULL) {
		_g_object_unref0 (userbox);
		return;
	}
	_tmp5_ = userbox;
	quick_settings_user_row_update_state (_tmp5_, NULL, NULL);
	_tmp6_ = self->priv->user_list_revealer;
	_tmp7_ = self->priv->listbox;
	_tmp8_ = gtk_list_box_get_row_at_index (_tmp7_, 0);
	gtk_revealer_set_reveal_child (_tmp6_, _tmp8_ != NULL);
	_g_object_unref0 (userbox);
}

void
quick_settings_user_list_update_all (QuickSettingsUserList* self)
{
	GHashTable* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->user_map;
	_tmp1_ = g_hash_table_get_values (_tmp0_);
	{
		GList* row_collection = NULL;
		GList* row_it = NULL;
		row_collection = _tmp1_;
		for (row_it = row_collection; row_it != NULL; row_it = row_it->next) {
			QuickSettingsUserRow* row = NULL;
			row = (QuickSettingsUserRow*) row_it->data;
			{
				QuickSettingsUserRow* _tmp2_;
				_tmp2_ = row;
				quick_settings_user_row_update_state (_tmp2_, NULL, NULL);
			}
		}
		(row_collection == NULL) ? NULL : (row_collection = (g_list_free (row_collection), NULL));
	}
}

gint
quick_settings_user_list_sort_func (QuickSettingsUserList* self,
                                    GtkListBoxRow* row1,
                                    GtkListBoxRow* row2)
{
	QuickSettingsUserRow* userbox1 = NULL;
	QuickSettingsUserRow* _tmp0_;
	QuickSettingsUserRow* userbox2 = NULL;
	QuickSettingsUserRow* _tmp1_;
	gboolean _tmp2_ = FALSE;
	QuickSettingsUserRow* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	QuickSettingsUserRow* _tmp16_;
	ActUser* _tmp17_;
	ActUser* _tmp18_;
	QuickSettingsUserRow* _tmp19_;
	ActUser* _tmp20_;
	ActUser* _tmp21_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (row1 != NULL, 0);
	g_return_val_if_fail (row2 != NULL, 0);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (row1, QUICK_SETTINGS_TYPE_USER_ROW, QuickSettingsUserRow));
	userbox1 = _tmp0_;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (row2, QUICK_SETTINGS_TYPE_USER_ROW, QuickSettingsUserRow));
	userbox2 = _tmp1_;
	_tmp3_ = userbox1;
	_tmp4_ = quick_settings_user_row_get_is_guest (_tmp3_);
	_tmp5_ = _tmp4_;
	if (_tmp5_) {
		QuickSettingsUserRow* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp6_ = userbox2;
		_tmp7_ = quick_settings_user_row_get_is_guest (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp2_ = !_tmp8_;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		result = 1;
		_g_object_unref0 (userbox2);
		_g_object_unref0 (userbox1);
		return result;
	} else {
		gboolean _tmp9_ = FALSE;
		QuickSettingsUserRow* _tmp10_;
		gboolean _tmp11_;
		gboolean _tmp12_;
		_tmp10_ = userbox1;
		_tmp11_ = quick_settings_user_row_get_is_guest (_tmp10_);
		_tmp12_ = _tmp11_;
		if (!_tmp12_) {
			QuickSettingsUserRow* _tmp13_;
			gboolean _tmp14_;
			gboolean _tmp15_;
			_tmp13_ = userbox2;
			_tmp14_ = quick_settings_user_row_get_is_guest (_tmp13_);
			_tmp15_ = _tmp14_;
			_tmp9_ = _tmp15_;
		} else {
			_tmp9_ = FALSE;
		}
		if (_tmp9_) {
			result = -1;
			_g_object_unref0 (userbox2);
			_g_object_unref0 (userbox1);
			return result;
		}
	}
	_tmp16_ = userbox1;
	_tmp17_ = quick_settings_user_row_get_user (_tmp16_);
	_tmp18_ = _tmp17_;
	_tmp19_ = userbox2;
	_tmp20_ = quick_settings_user_row_get_user (_tmp19_);
	_tmp21_ = _tmp20_;
	result = act_user_collate (_tmp18_, _tmp21_);
	_g_object_unref0 (userbox2);
	_g_object_unref0 (userbox1);
	return result;
}

static void
quick_settings_user_list_show_settings (QuickSettingsUserList* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		g_app_info_launch_default_for_uri ("settings://accounts", NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp0_ = e;
		_tmp1_ = _tmp0_->message;
		g_warning ("UserList.vala:241: %s\n", _tmp1_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

QuickSettingsUserList*
quick_settings_user_list_construct (GType object_type)
{
	QuickSettingsUserList * self = NULL;
	self = (QuickSettingsUserList*) g_object_new (object_type, NULL);
	return self;
}

QuickSettingsUserList*
quick_settings_user_list_new (void)
{
	return quick_settings_user_list_construct (QUICK_SETTINGS_TYPE_USER_LIST);
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
	g_atomic_int_inc (&_data9_->_ref_count_);
	return _data9_;
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
		QuickSettingsUserList* self;
		self = _data9_->self;
		_g_free0 (_data9_->session_path);
		_g_object_unref0 (_data9_->current_user);
		_g_object_unref0 (self);
		g_slice_free (Block9Data, _data9_);
	}
}

static guint
_quick_settings_user_list___lambda5_ (uid_t* k)
{
	guint result;
	result = (guint) (*k);
	return result;
}

static guint
__quick_settings_user_list___lambda5__ghash_func (gconstpointer key)
{
	guint result;
	result = _quick_settings_user_list___lambda5_ ((uid_t*) key);
	return result;
}

static gboolean
_uid_t_equal (const uid_t * s1,
              const uid_t * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	return (*s1) == (*s2);
}

static gboolean
_quick_settings_user_list___lambda6_ (uid_t* k1,
                                      uid_t* k2)
{
	gboolean result;
	result = _uid_t_equal (k1, k2) == TRUE;
	return result;
}

static gboolean
__quick_settings_user_list___lambda6__gequal_func (gconstpointer a,
                                                   gconstpointer b)
{
	gboolean result;
	result = _quick_settings_user_list___lambda6_ ((uid_t*) a, (uid_t*) b);
	return result;
}

static void
_g_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_free (var), NULL));
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static gint
_quick_settings_user_list_sort_func_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                            GtkListBoxRow* row2,
                                                            gpointer self)
{
	gint result;
	result = quick_settings_user_list_sort_func ((QuickSettingsUserList*) self, row1, row2);
	return result;
}

static void
_quick_settings_user_list____lambda12_ (QuickSettingsUserList* self)
{
	quick_settings_user_list_init_users (self);
}

static void
__quick_settings_user_list____lambda12__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self)
{
	_quick_settings_user_list____lambda12_ ((QuickSettingsUserList*) self);
}

static void
_quick_settings_user_list_add_user_act_user_manager_user_added (ActUserManager* _sender,
                                                                ActUser* user,
                                                                gpointer self)
{
	quick_settings_user_list_add_user ((QuickSettingsUserList*) self, user);
}

static void
_quick_settings_user_list_remove_user_act_user_manager_user_removed (ActUserManager* _sender,
                                                                     ActUser* user,
                                                                     gpointer self)
{
	quick_settings_user_list_remove_user ((QuickSettingsUserList*) self, user);
}

static void
_quick_settings_user_list_update_user_act_user_manager_user_changed (ActUserManager* _sender,
                                                                     ActUser* user,
                                                                     gpointer self)
{
	quick_settings_user_list_update_user ((QuickSettingsUserList*) self, user);
}

static void
_quick_settings_user_list____lambda13_ (QuickSettingsUserList* self)
{
	GError* _inner_error0_ = NULL;
	{
		QuickSettingsSeatInterface* _tmp0_;
		_tmp0_ = self->priv->dm_proxy;
		quick_settings_seat_interface_switch_to_guest (_tmp0_, "", &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = e;
		_tmp2_ = _tmp1_->message;
		g_warning ("UserList.vala:92: Error switching to guest account: %s", _tmp2_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
__quick_settings_user_list____lambda13__quick_settings_user_list_switch_to_guest (QuickSettingsUserList* _sender,
                                                                                  gpointer self)
{
	_quick_settings_user_list____lambda13_ ((QuickSettingsUserList*) self);
}

static void
_quick_settings_user_list____lambda14_ (Block9Data* _data9_,
                                        const gchar* username)
{
	QuickSettingsUserList* self;
	GError* _inner_error0_ = NULL;
	self = _data9_->self;
	g_return_if_fail (username != NULL);
	{
		QuickSettingsSeatInterface* _tmp0_;
		const gchar* _tmp1_;
		_tmp0_ = self->priv->dm_proxy;
		_tmp1_ = _data9_->session_path;
		quick_settings_seat_interface_switch_to_user (_tmp0_, username, _tmp1_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp2_ = e;
		_tmp3_ = _tmp2_->message;
		g_warning ("UserList.vala:100: Error switching to user '%s': %s", username, _tmp3_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
__quick_settings_user_list____lambda14__quick_settings_user_list_switch_to_user (QuickSettingsUserList* _sender,
                                                                                 const gchar* username,
                                                                                 gpointer self)
{
	_quick_settings_user_list____lambda14_ (self, username);
}

static void
_quick_settings_user_list___lambda15_ (QuickSettingsUserList* self,
                                       GtkListBoxRow* row)
{
	QuickSettingsUserRow* userbox = NULL;
	QuickSettingsUserRow* _tmp0_;
	QuickSettingsUserRow* _tmp1_;
	GtkPopover* _tmp2_;
	QuickSettingsUserRow* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	g_return_if_fail (row != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (row, QUICK_SETTINGS_TYPE_USER_ROW, QuickSettingsUserRow));
	userbox = _tmp0_;
	_tmp1_ = userbox;
	if (_tmp1_ == NULL) {
		_g_object_unref0 (userbox);
		return;
	}
	_tmp2_ = self->priv->popover;
	gtk_popover_popdown (_tmp2_);
	_tmp3_ = userbox;
	_tmp4_ = quick_settings_user_row_get_is_guest (_tmp3_);
	_tmp5_ = _tmp4_;
	if (_tmp5_) {
		g_signal_emit (self, quick_settings_user_list_signals[QUICK_SETTINGS_USER_LIST_SWITCH_TO_GUEST_SIGNAL], 0);
	} else {
		ActUser* user = NULL;
		QuickSettingsUserRow* _tmp6_;
		ActUser* _tmp7_;
		ActUser* _tmp8_;
		ActUser* _tmp9_;
		ActUser* _tmp10_;
		_tmp6_ = userbox;
		_tmp7_ = quick_settings_user_row_get_user (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = _g_object_ref0 (_tmp8_);
		user = _tmp9_;
		_tmp10_ = user;
		if (_tmp10_ != NULL) {
			ActUser* _tmp11_;
			const gchar* _tmp12_;
			_tmp11_ = user;
			_tmp12_ = act_user_get_user_name (_tmp11_);
			g_signal_emit (self, quick_settings_user_list_signals[QUICK_SETTINGS_USER_LIST_SWITCH_TO_USER_SIGNAL], 0, _tmp12_);
		}
		_g_object_unref0 (user);
	}
	_g_object_unref0 (userbox);
}

static void
__quick_settings_user_list___lambda15__gtk_list_box_row_activated (GtkListBox* _sender,
                                                                   GtkListBoxRow* row,
                                                                   gpointer self)
{
	_quick_settings_user_list___lambda15_ ((QuickSettingsUserList*) self, row);
}

static void
_quick_settings_user_list___lambda16_ (QuickSettingsUserList* self)
{
	quick_settings_user_list_show_settings (self);
}

static void
__quick_settings_user_list___lambda16__gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self)
{
	_quick_settings_user_list___lambda16_ ((QuickSettingsUserList*) self);
}

static void
_quick_settings_user_list___lambda17_ (QuickSettingsUserList* self)
{
	GtkWidget* _tmp0_;
	GtkPopover* _tmp1_;
	_tmp0_ = gtk_widget_get_ancestor ((GtkWidget*) self, gtk_popover_get_type ());
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_popover_get_type (), GtkPopover));
	_g_object_unref0 (self->priv->popover);
	self->priv->popover = _tmp1_;
}

static void
__quick_settings_user_list___lambda17__gtk_widget_realize (GtkWidget* _sender,
                                                           gpointer self)
{
	_quick_settings_user_list___lambda17_ ((QuickSettingsUserList*) self);
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
	g_atomic_int_inc (&_data10_->_ref_count_);
	return _data10_;
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
		QuickSettingsUserList* self;
		self = _data10_->_data9_->self;
		_g_object_unref0 (_data10_->session_interface);
		block9_data_unref (_data10_->_data9_);
		_data10_->_data9_ = NULL;
		g_slice_free (Block10Data, _data10_);
	}
}

static void
__lambda20_ (Block10Data* _data10_,
             GObject* obj,
             GAsyncResult* res)
{
	Block9Data* _data9_;
	QuickSettingsUserList* self;
	GError* _inner_error0_ = NULL;
	_data9_ = _data10_->_data9_;
	self = _data9_->self;
	g_return_if_fail (res != NULL);
	{
		QuickSettingsSessionInterface* _tmp0_;
		_tmp0_ = _data10_->session_interface;
		quick_settings_session_interface_logout_finish (_tmp0_, res, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = e;
		if (!g_error_matches (_tmp1_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
			GError* _tmp2_;
			const gchar* _tmp3_;
			_tmp2_ = e;
			_tmp3_ = _tmp2_->message;
			g_warning ("UserList.vala:142: Unable to open logout dialog: %s", _tmp3_);
		}
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
___lambda20__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	__lambda20_ (self, source_object, res);
	block10_data_unref (self);
}

static void
__lambda19_ (Block10Data* _data10_)
{
	Block9Data* _data9_;
	QuickSettingsUserList* self;
	GtkPopover* _tmp0_;
	QuickSettingsSessionInterface* _tmp1_;
	_data9_ = _data10_->_data9_;
	self = _data9_->self;
	_tmp0_ = self->priv->popover;
	gtk_popover_popdown (_tmp0_);
	_tmp1_ = _data10_->session_interface;
	quick_settings_session_interface_logout (_tmp1_, (guint) 0, ___lambda20__gasync_ready_callback, block10_data_ref (_data10_));
}

static void
___lambda19__quick_settings_current_user_logout (QuickSettingsCurrentUser* _sender,
                                                 gpointer self)
{
	__lambda19_ (self);
}

static void
_quick_settings_user_list___lambda18_ (Block9Data* _data9_,
                                       GObject* obj,
                                       GAsyncResult* res)
{
	QuickSettingsUserList* self;
	Block10Data* _data10_;
	QuickSettingsSessionInterface* _tmp0_;
	QuickSettingsCurrentUser* _tmp1_;
	self = _data9_->self;
	g_return_if_fail (res != NULL);
	_data10_ = g_slice_new0 (Block10Data);
	_data10_->_ref_count_ = 1;
	_data10_->_data9_ = block9_data_ref (_data9_);
	_tmp0_ = quick_settings_user_manager_setup_session_interface_finish (res);
	_data10_->session_interface = _tmp0_;
	_tmp1_ = _data9_->current_user;
	g_signal_connect_data (_tmp1_, "logout", (GCallback) ___lambda19__quick_settings_current_user_logout, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
	block10_data_unref (_data10_);
	_data10_ = NULL;
}

static void
__quick_settings_user_list___lambda18__gasync_ready_callback (GObject* source_object,
                                                              GAsyncResult* res,
                                                              gpointer self)
{
	_quick_settings_user_list___lambda18_ (self, source_object, res);
	block9_data_unref (self);
}

static GObject *
quick_settings_user_list_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	QuickSettingsUserList * self;
	Block9Data* _data9_;
	GHashTable* _tmp0_;
	QuickSettingsCurrentUser* _tmp1_;
	GtkListBox* _tmp2_ = NULL;
	GtkListBox* _tmp3_;
	GtkScrolledWindow* listbox_scrolled = NULL;
	GtkListBox* _tmp4_;
	GtkWidget* _tmp5_;
	GtkScrolledWindow* _tmp6_ = NULL;
	GtkModelButton* settings_button = NULL;
	gchar* _tmp7_;
	GtkModelButton* _tmp8_ = NULL;
	GtkBox* user_list_vbox = NULL;
	GtkBox* _tmp9_;
	GtkBox* _tmp10_;
	GtkSeparator* _tmp11_;
	GtkSeparator* _tmp12_;
	GtkBox* _tmp13_;
	GtkScrolledWindow* _tmp14_;
	GtkBox* _tmp15_;
	GtkWidget* _tmp16_;
	GtkRevealer* _tmp17_ = NULL;
	QuickSettingsCurrentUser* _tmp18_;
	GtkRevealer* _tmp19_;
	GtkSeparator* _tmp20_;
	GtkSeparator* _tmp21_;
	GtkModelButton* _tmp22_;
	ActUserManager* _tmp23_;
	gboolean _tmp24_;
	gboolean _tmp25_;
	ActUserManager* _tmp27_;
	ActUserManager* _tmp28_;
	ActUserManager* _tmp29_;
	gchar* seat_path = NULL;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	const gchar* _tmp34_;
	QuickSettingsSeatInterface* _tmp47_;
	GtkListBox* _tmp48_;
	GtkModelButton* _tmp49_;
	GError* _inner_error0_ = NULL;
	parent_class = G_OBJECT_CLASS (quick_settings_user_list_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, QUICK_SETTINGS_TYPE_USER_LIST, QuickSettingsUserList);
	_data9_ = g_slice_new0 (Block9Data);
	_data9_->_ref_count_ = 1;
	_data9_->self = g_object_ref (self);
	_tmp0_ = g_hash_table_new_full (__quick_settings_user_list___lambda5__ghash_func, __quick_settings_user_list___lambda6__gequal_func, _g_free0_, _g_object_unref0_);
	_g_hash_table_unref0 (self->priv->user_map);
	self->priv->user_map = _tmp0_;
	_tmp1_ = quick_settings_current_user_new ();
	g_object_ref_sink (_tmp1_);
	_data9_->current_user = _tmp1_;
	_tmp2_ = (GtkListBox*) gtk_list_box_new ();
	gtk_widget_set_hexpand ((GtkWidget*) _tmp2_, TRUE);
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->listbox);
	self->priv->listbox = _tmp2_;
	_tmp3_ = self->priv->listbox;
	gtk_list_box_set_sort_func (_tmp3_, _quick_settings_user_list_sort_func_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
	_tmp4_ = self->priv->listbox;
	_tmp5_ = _g_object_ref0 ((GtkWidget*) _tmp4_);
	_tmp6_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_set (_tmp6_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
	gtk_scrolled_window_set_max_content_height (_tmp6_, 200);
	gtk_scrolled_window_set_propagate_natural_height (_tmp6_, TRUE);
	g_object_set ((GtkContainer*) _tmp6_, "child", _tmp5_, NULL);
	_g_object_unref0 (_tmp5_);
	g_object_ref_sink (_tmp6_);
	listbox_scrolled = _tmp6_;
	_tmp7_ = g_strdup (_ ("User Accounts Settings…"));
	_tmp8_ = (GtkModelButton*) gtk_model_button_new ();
	g_object_set (_tmp8_, "text", _tmp7_, NULL);
	_g_free0 (_tmp7_);
	g_object_ref_sink (_tmp8_);
	settings_button = _tmp8_;
	_tmp9_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp9_);
	user_list_vbox = _tmp9_;
	_tmp10_ = user_list_vbox;
	_tmp11_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp11_);
	_tmp12_ = _tmp11_;
	gtk_container_add ((GtkContainer*) _tmp10_, (GtkWidget*) _tmp12_);
	_g_object_unref0 (_tmp12_);
	_tmp13_ = user_list_vbox;
	_tmp14_ = listbox_scrolled;
	gtk_container_add ((GtkContainer*) _tmp13_, (GtkWidget*) _tmp14_);
	_tmp15_ = user_list_vbox;
	_tmp16_ = _g_object_ref0 ((GtkWidget*) _tmp15_);
	_tmp17_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_set ((GtkContainer*) _tmp17_, "child", _tmp16_, NULL);
	_g_object_unref0 (_tmp16_);
	gtk_revealer_set_reveal_child (_tmp17_, FALSE);
	g_object_ref_sink (_tmp17_);
	_g_object_unref0 (self->priv->user_list_revealer);
	self->priv->user_list_revealer = _tmp17_;
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
	_tmp18_ = _data9_->current_user;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp18_);
	_tmp19_ = self->priv->user_list_revealer;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp19_);
	_tmp20_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp20_);
	_tmp21_ = _tmp20_;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp21_);
	_g_object_unref0 (_tmp21_);
	_tmp22_ = settings_button;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp22_);
	_tmp23_ = quick_settings_user_manager_get_usermanager ();
	g_object_get (_tmp23_, "is-loaded", &_tmp24_, NULL);
	_tmp25_ = _tmp24_;
	if (_tmp25_) {
		quick_settings_user_list_init_users (self);
	} else {
		ActUserManager* _tmp26_;
		_tmp26_ = quick_settings_user_manager_get_usermanager ();
		g_signal_connect_object ((GObject*) _tmp26_, "notify::is-loaded", (GCallback) __quick_settings_user_list____lambda12__g_object_notify, self, 0);
	}
	_tmp27_ = quick_settings_user_manager_get_usermanager ();
	g_signal_connect_object (_tmp27_, "user-added", (GCallback) _quick_settings_user_list_add_user_act_user_manager_user_added, self, 0);
	_tmp28_ = quick_settings_user_manager_get_usermanager ();
	g_signal_connect_object (_tmp28_, "user-removed", (GCallback) _quick_settings_user_list_remove_user_act_user_manager_user_removed, self, 0);
	_tmp29_ = quick_settings_user_manager_get_usermanager ();
	g_signal_connect_object (_tmp29_, "user-changed", (GCallback) _quick_settings_user_list_update_user_act_user_manager_user_changed, self, 0);
	_tmp30_ = g_getenv ("XDG_SEAT_PATH");
	_tmp31_ = g_strdup (_tmp30_);
	seat_path = _tmp31_;
	_tmp32_ = g_getenv ("XDG_SESSION_PATH");
	_tmp33_ = g_strdup (_tmp32_);
	_data9_->session_path = _tmp33_;
	_tmp34_ = seat_path;
	if (_tmp34_ != NULL) {
		{
			QuickSettingsSeatInterface* _tmp35_ = NULL;
			const gchar* _tmp36_;
			QuickSettingsSeatInterface* _tmp37_;
			QuickSettingsSeatInterface* _tmp38_;
			gboolean _tmp39_ = FALSE;
			QuickSettingsSeatInterface* _tmp40_;
			gboolean _tmp41_;
			gboolean _tmp42_;
			_tmp36_ = seat_path;
			_tmp37_ = (QuickSettingsSeatInterface*) g_initable_new (QUICK_SETTINGS_TYPE_SEAT_INTERFACE_PROXY, NULL, &_inner_error0_, "g-flags", G_DBUS_PROXY_FLAGS_NONE, "g-name", QUICK_SETTINGS_USER_LIST_DM_DBUS_ID, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", _tmp36_, "g-interface-name", "org.freedesktop.DisplayManager.Seat", NULL);
			_tmp35_ = (QuickSettingsSeatInterface*) _tmp37_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == G_IO_ERROR) {
					goto __catch0_g_io_error;
				}
				_g_free0 (seat_path);
				_g_object_unref0 (user_list_vbox);
				_g_object_unref0 (settings_button);
				_g_object_unref0 (listbox_scrolled);
				block9_data_unref (_data9_);
				_data9_ = NULL;
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
			}
			_tmp38_ = _tmp35_;
			_tmp35_ = NULL;
			_g_object_unref0 (self->priv->dm_proxy);
			self->priv->dm_proxy = _tmp38_;
			_tmp40_ = self->priv->dm_proxy;
			_tmp41_ = quick_settings_seat_interface_get_has_guest_account (_tmp40_);
			_tmp42_ = _tmp41_;
			if (_tmp42_) {
				ActUser* _tmp43_;
				ActUser* _tmp44_;
				_tmp43_ = quick_settings_user_manager_get_current_user ();
				_tmp44_ = _tmp43_;
				_tmp39_ = _tmp44_ != NULL;
				_g_object_unref0 (_tmp44_);
			} else {
				_tmp39_ = FALSE;
			}
			if (_tmp39_) {
				quick_settings_user_list_add_guest (self);
			}
			_g_object_unref0 (_tmp35_);
		}
		goto __finally0;
		__catch0_g_io_error:
		{
			GError* e = NULL;
			GError* _tmp45_;
			const gchar* _tmp46_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp45_ = e;
			_tmp46_ = _tmp45_->message;
			g_critical ("UserList.vala:83: UserManager error: %s", _tmp46_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (seat_path);
			_g_object_unref0 (user_list_vbox);
			_g_object_unref0 (settings_button);
			_g_object_unref0 (listbox_scrolled);
			block9_data_unref (_data9_);
			_data9_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
		}
	}
	_tmp47_ = self->priv->dm_proxy;
	if (_tmp47_ != NULL) {
		g_signal_connect_object (self, "switch-to-guest", (GCallback) __quick_settings_user_list____lambda13__quick_settings_user_list_switch_to_guest, self, 0);
		g_signal_connect_data (self, "switch-to-user", (GCallback) __quick_settings_user_list____lambda14__quick_settings_user_list_switch_to_user, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
	}
	_tmp48_ = self->priv->listbox;
	g_signal_connect_object (_tmp48_, "row-activated", (GCallback) __quick_settings_user_list___lambda15__gtk_list_box_row_activated, self, 0);
	_tmp49_ = settings_button;
	g_signal_connect_object ((GtkButton*) _tmp49_, "clicked", (GCallback) __quick_settings_user_list___lambda16__gtk_button_clicked, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "realize", (GCallback) __quick_settings_user_list___lambda17__gtk_widget_realize, self, 0);
	quick_settings_user_manager_setup_session_interface (__quick_settings_user_list___lambda18__gasync_ready_callback, block9_data_ref (_data9_));
	_g_free0 (seat_path);
	_g_object_unref0 (user_list_vbox);
	_g_object_unref0 (settings_button);
	_g_object_unref0 (listbox_scrolled);
	block9_data_unref (_data9_);
	_data9_ = NULL;
	return obj;
}

static void
quick_settings_user_list_class_init (QuickSettingsUserListClass * klass,
                                     gpointer klass_data)
{
	quick_settings_user_list_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &QuickSettingsUserList_private_offset);
	G_OBJECT_CLASS (klass)->constructor = quick_settings_user_list_constructor;
	G_OBJECT_CLASS (klass)->finalize = quick_settings_user_list_finalize;
	quick_settings_user_list_signals[QUICK_SETTINGS_USER_LIST_SWITCH_TO_GUEST_SIGNAL] = g_signal_new ("switch-to-guest", QUICK_SETTINGS_TYPE_USER_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	quick_settings_user_list_signals[QUICK_SETTINGS_USER_LIST_SWITCH_TO_USER_SIGNAL] = g_signal_new ("switch-to-user", QUICK_SETTINGS_TYPE_USER_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
}

static void
quick_settings_user_list_instance_init (QuickSettingsUserList * self,
                                        gpointer klass)
{
	self->priv = quick_settings_user_list_get_instance_private (self);
	self->priv->dm_proxy = NULL;
}

static void
quick_settings_user_list_finalize (GObject * obj)
{
	QuickSettingsUserList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, QUICK_SETTINGS_TYPE_USER_LIST, QuickSettingsUserList);
	_g_object_unref0 (self->priv->dm_proxy);
	_g_hash_table_unref0 (self->priv->user_map);
	_g_object_unref0 (self->priv->listbox);
	_g_object_unref0 (self->priv->popover);
	_g_object_unref0 (self->priv->user_list_revealer);
	G_OBJECT_CLASS (quick_settings_user_list_parent_class)->finalize (obj);
}

static GType
quick_settings_user_list_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (QuickSettingsUserListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) quick_settings_user_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (QuickSettingsUserList), 0, (GInstanceInitFunc) quick_settings_user_list_instance_init, NULL };
	GType quick_settings_user_list_type_id;
	quick_settings_user_list_type_id = g_type_register_static (gtk_box_get_type (), "QuickSettingsUserList", &g_define_type_info, 0);
	QuickSettingsUserList_private_offset = g_type_add_instance_private (quick_settings_user_list_type_id, sizeof (QuickSettingsUserListPrivate));
	return quick_settings_user_list_type_id;
}

GType
quick_settings_user_list_get_type (void)
{
	static volatile gsize quick_settings_user_list_type_id__once = 0;
	if (g_once_init_enter (&quick_settings_user_list_type_id__once)) {
		GType quick_settings_user_list_type_id;
		quick_settings_user_list_type_id = quick_settings_user_list_get_type_once ();
		g_once_init_leave (&quick_settings_user_list_type_id__once, quick_settings_user_list_type_id);
	}
	return quick_settings_user_list_type_id__once;
}

